//*************************************************************************************************
//   Тест SDK для FLProg; Библиотека RT_HW_BASE.h;        Версия 0.2 21.06.2020; ecoins@mail.ru
//   Тест SDK для FLProg; Библиотека RT_HW_LCD_HD44780.h; Версия 0.2 21.06.2020; ecoins@mail.ru
//*************************************************************************************************
#include  "RT_HW_BASE.h"
#include  "RT_HW_LCD_HD44780.h"
#include  "t01_device.hpp"    //--Установка номеров пинов, адресов, параметров для конкретного контроллера;
#include  "t02_id_head.hpp"   //--Вывод заголовков;
#include  "t00_device.hpp"    //--Переменные,заголовки,счетчики,объекты и т.п.

//------------------------------------------------------------------------------------------------

//#################################################################################################
//=================================================================================================
void setup() {}
//=================================================================================================
void loop() {
//-------------------------------------------------------------------------------------------------
//                  НАСТРОЙКА ПАРАМЕТРОВ (выполняется один раз)
//-------------------------------------------------------------------------------------------------
  if (!initParam) {initParam = 1; setNumUserParam();};
//-------------------------------------------------------------------------------------------------
//                    ГЛАВНАЯ ЗАДАЧА
//-------------------------------------------------------------------------------------------------
  RT_HW_Base.sheduler();                                                  //--Мини-диспетчер;
  numQuick = RT_HW_Base.shed.quick.num; numFast = RT_HW_Base.shed.fast.num; //--Установка
  numSlow  = RT_HW_Base.shed.slow.num;  numBack = RT_HW_Base.shed.back.num; //      номеров
  numFrdm  = RT_HW_Base.shed.frdm.num;                                     //            задач;
  RT_HW_Base.printBegin(115200); runConsoleHead = RT_HW_Base.console.head; //--Установка флага запуска задачи "Вывод заголовков";
  //-------Вывод сигнала "Контроль" на пин (ускоренный вывод)--------------
  if (idCnt.dir == 0) {idCnt.dir = 7; if (idCnt.mode == 0) {RT_HW_Base.directPinSetID(idCnt, pinCnt); if (bitRead(idCnt.mode, RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_OUTPUT(idCnt);} idCnt.dir = 1;} }
  if (idCnt.dir == 1) {RT_HW_PIN_DIR_WRITE(idCnt, bitRead(RT_HW_Base.shed.blink, 0));}
//-------------------------------------------------------------------------------------------------
//                      ВЫВОД ЗАГОЛОВКОВ (однократный вывод после готовности консоли)
//-------------------------------------------------------------------------------------------------
  if (runConsoleHead) { printHeadUser(); RT_HW_Base.console.resetHead = 1;}
//=================================================================================================
//                      ВЫВОД на i2c LCD=i2c_lcd1
//=================================================================================================
    if (numFrdm == 5) {
    if (num_1 == 15) {num_1 = RT_HW_Lcd_hd44780.setDevice(num_1, 'I', i2c_lcd1, 20, 4, 60);}
    //--Супервизор LCD=num_1---------------------------------------------------------------------------
    RT_HW_Lcd_hd44780.directDevice(num_1);
    //--Мерцание в позиции 1,1-------------------------------------------------------------------------
    if (!idLcdBlink11.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink11, num_1, 1, 1, 'F', 10);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink11, vnBlock, vnBlink, ' ', '*');
    //--Мерцание в позиции 1,2-------------------------------------------------------------------------
    if (!idLcdBlink12.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink12, num_1, 1, 2, 'F', 12);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink12, vnBlock, vnBlink, '-', '+');
    //--Вывод bool в позицию 3,2------------------------------------------------------------------------
    if (!idLcdBit11.custom)  {RT_HW_Lcd_hd44780.setIdChar(idLcdBit11,    num_1, 2, 2, 'B', 2);}  idLcdBit11.boolVal = vnBut;
                                                                                                 RT_HW_Lcd_hd44780.printIdChar(idLcdBit11,  vnBlock, vnBlink, '0', '1');
    //--Вывод char в позицию 5,2------------------------------------------------------------------------
    if (!idLcdChar11.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdChar11,   num_1, 3, 2, 'C', 5);}  RT_HW_Lcd_hd44780.printIdChar(idLcdChar11, vnBlock, vnBlink, vChar);
    //--Вывод ADC(int16) с заголовком--------------------------------------------------------------------------
    if (!idLcdIADC11.custom) {RT_HW_Lcd_hd44780.setIdVal(idLcdIADC11,  num_1, 2, 1, 8, 5);}   
    if ( idLcdIADC11.dir == 1) {if (vnAgoADC11 != vnADC) {vnAgoADC11 = vnADC; idLcdIADC11.event.fresh = 1;}}
    RT_HW_Lcd_hd44780.printIdVal(idLcdIADC11,  vnBlock, vnBlink, 'L', '0', vnADC, ';', PGM_aE);
    //--Вывод ADC(float) с заголовком-------------------------------------------------------------------------
    if (!idLcdFADC11.custom) {RT_HW_Lcd_hd44780.setIdVal(idLcdFADC11,  num_1, 10, 1, 7, 5);}
    if ( idLcdFADC11.dir == 1) {RT_HW_Lcd_hd44780.device.ibuff32 = RT_HW_Lcd_hd44780.floatToInt32(vFADC, 2); 
                                if (buffFADC11 != RT_HW_Lcd_hd44780.device.ibuff32) {buffFADC11 = RT_HW_Lcd_hd44780.device.ibuff32; idLcdFADC11.event.fresh = 1;}}
                                                                                                  RT_HW_Lcd_hd44780.printIdVal(idLcdFADC11,  vnBlock, vnBlink, 'L', '2', buffFADC11, ';', PGM_vE);
    //--Вывод PWM(HEX) с заголовком-------------------------------------------------------------------------
    if (!idLcdPWM11.custom)  {RT_HW_Lcd_hd44780.setIdVal(idLcdPWM11, num_1, 5, 2, 7, 10);}   
    if (idLcdPWM11.dir == 1) {if (vdAgoPWM11 != vdPWM) {vdAgoPWM11 = vdPWM; idLcdPWM11.event.fresh = 1; }}
                                                                                                  RT_HW_Lcd_hd44780.printIdVal(idLcdPWM11,    vnBlock, vnBlink, 'L', 'H', vdPWM,    ';', PGM_HE);
  } //--END (numFrdm == 5)
//=================================================================================================
//                      ВЫВОД на i2c LCD=i2c_lcd2
//=================================================================================================
  if (numFrdm == 10) {
    if (num_2 == 15) {num_2 = RT_HW_Lcd_hd44780.setDevice(num_2, 'I', i2c_lcd2, 20, 4, 120);}
    //-------------------------------------------------------------------------------------------------
    RT_HW_Lcd_hd44780.directDevice(num_2);
    //--Мерцание в позиции 1,1-------------------------------------------------------------------------
    if (!idLcdBlink21.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink21, num_2, 1, 1, 'F', 10);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink21, vnBlock, vnBlink, ' ', '*');
    //--Мерцание в позиции 1,2-------------------------------------------------------------------------
    if (!idLcdBlink22.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink22, num_2, 1, 2, 'F', 12);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink22, vnBlock, vnBlink, '-', '+');
    //--Вывод bool в позицию 3,2-----------------------------------------------------------------------
    if (!idLcdBit21.custom)   {RT_HW_Lcd_hd44780.setIdChar(idLcdBit21,   num_2, 2, 2, 'B', 2);} idLcdBit21.boolVal = vnBut;
                                                                                                RT_HW_Lcd_hd44780.printIdChar(idLcdBit21,  vnBlock, vnBlink, '0', '1');
    //--Вывод char в позицию 3,2------------------------------------------------------------------------
    if (!idLcdChar21.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdChar21,   num_2, 3, 2, 'C', 5);} RT_HW_Lcd_hd44780.printIdChar(idLcdChar21, vnBlock, vnBlink, vChar);
    //--Вывод ADC(int16) с заголовком-------------------------------------------------------------------
    if (!idLcdIADC21.custom) {RT_HW_Lcd_hd44780.setIdVal(idLcdIADC21,    num_2, 2, 1, 8, 5);}  
    if ( idLcdIADC21.dir == 1) {if (vnAgoADC21 != vnADC) {vnAgoADC21 = vnADC; idLcdIADC21.event.fresh = 1;}}
                                                                                                RT_HW_Lcd_hd44780.printIdVal(idLcdIADC21, vnBlock, vnBlink, 'L', 'D', vnADC, ';', PGM_ADC);
    //--Вывод (HEX) с заголовком------------------------------------------------------------------------
    if (!idLcdPWM21.custom)  {RT_HW_Lcd_hd44780.setIdVal (idLcdPWM21, num_2, 4, 2, 5, 5);}  
    if (idLcdPWM21.dir == 1) {if (vdAgoPWM21 != vdPWM) {vdAgoPWM21 = vdPWM; idLcdPWM21.event.fresh = 1;}}
                                                                                                RT_HW_Lcd_hd44780.printIdVal(idLcdPWM21, vnBlock, vnBlink, 'L', 'h', vdAgoPWM21, ';', PGM_hE);
    //--Вывод TXT_PGM-----------------------------------------------------------------------------------
    if (!idLcdPGM21.custom)  {RT_HW_Lcd_hd44780.setIdText(idLcdPGM21,   num_2, 9, 2, 8, 10);}
    if (idLcdPGM21.dir == 1) {if (cntAgoPGM11 != cntNumTextPGM) {cntAgoPGM11 = cntNumTextPGM; textN21 = getNameStrPGM(cntNumTextPGM); idLcdPGM21.event.fresh = 1;}}
                                                                                                RT_HW_Lcd_hd44780.printTextPGM(idLcdPGM21, vnBlock, vnBlink, 'C', textN21);
    //--Вывод TXT_STR-----------------------------------------------------------------------------------
    if (!idLcdSTR21.custom)  {RT_HW_Lcd_hd44780.setIdText(idLcdSTR21,   num_2, 10, 1, 7, 10);}
    if (idLcdSTR21.dir == 1) {RT_HW_Lcd_hd44780.device.buff16 = RT_HW_Lcd_hd44780.CRC16_String(vStr);
                              if (crcAgoSTR21 != RT_HW_Lcd_hd44780.device.buff16) {crcAgoSTR21 = RT_HW_Lcd_hd44780.device.buff16; idLcdSTR21.event.fresh = 1;}}
                              RT_HW_Lcd_hd44780.printTextSTR(idLcdSTR21, vnBlock, vnBlink, 'C', vStr);
  } //--END (numFrdm == 10)
  //=================================================================================================
  //                      ВЫВОД через 6 пинов LCD №3
  //=================================================================================================
  if (numFrdm == 15) {
    if (num_3 == 15) {num_3 = RT_HW_Lcd_hd44780.setDevice(num_3, 'B', lcdPin6, 20, 4, 100);}
    //-------------------------------------------------------------------------------------------------
    RT_HW_Lcd_hd44780.directDevice(num_3);
    //--Мерцание в позиции 1,1-------------------------------------------------------------------------
    if (!idLcdBlink31.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink31, num_3, 1, 1, 'F', 10);}  RT_HW_Lcd_hd44780.printIdChar(idLcdBlink31, vnBlock, vnBlink, ' ', '*');
    //--Мерцание в позиции 1,2-------------------------------------------------------------------------
    if (!idLcdBlink32.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdBlink32, num_3, 1, 2, 'F', 12);}  RT_HW_Lcd_hd44780.printIdChar(idLcdBlink32, vnBlock, vnBlink, '-', '+');
    //--Вывод bool в позицию 3,2-----------------------------------------------------------------------
    if (!idLcdBit31.custom)   {RT_HW_Lcd_hd44780.setIdChar(idLcdBit31,   num_3, 2, 2, 'B', 2);} idLcdBit31.boolVal = vnBut;
                                                                                                  RT_HW_Lcd_hd44780.printIdChar(idLcdBit31,  vnBlock, vnBlink, '0', '1');
    //--Вывод char в позицию 3,2------------------------------------------------------------------------
    if (!idLcdChar31.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdChar31,   num_3, 3, 2, 'C', 5);}   RT_HW_Lcd_hd44780.printIdChar(idLcdChar31, vnBlock, vnBlink, vChar);
    //--Вывод TXT_PGM-----------------------------------------------------------------------
    if (!idLcdPGM31.custom)  {RT_HW_Lcd_hd44780.setIdText(idLcdPGM31,    num_3, 9, 2, 8, 10);}
    if (idLcdPGM31.dir == 1) {if (cntAgoPGM31 != cntNumTextPGM) {cntAgoPGM31 = cntNumTextPGM; textN31 = getNameStrPGM(cntNumTextPGM); idLcdPGM31.event.fresh = 1;}}
    RT_HW_Lcd_hd44780.printTextPGM(idLcdPGM31, vnBlock, vnBlink, 'C', textN31);
  } //--END (numFrdm == 15)
  //=================================================================================================
  //                      ВЫВОД через SPI LCD №4
  //=================================================================================================
  if (numFrdm == 18) {
    if (num_4 == 15) {num_4 = RT_HW_Lcd_hd44780.setDevice(num_4, 'S', SPI_lcd, 20, 4, 10);}
    //------------------------------------------------------------------------------------------------
    RT_HW_Lcd_hd44780.directDevice(num_4);
    //--Мерцание в позиции 1,1-------------------------------------------------------------------------
    if (!idLcdBlink41.custom){RT_HW_Lcd_hd44780.setIdChar(idLcdBlink41, num_4, 1, 1, 'F', 10);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink41, vnBlock, vnBlink, ' ', '*');
    //--Мерцание в позиции 1,2-------------------------------------------------------------------------
    if (!idLcdBlink42.custom){RT_HW_Lcd_hd44780.setIdChar(idLcdBlink42, num_4, 1, 2, 'F', 12);} RT_HW_Lcd_hd44780.printIdChar(idLcdBlink42, vnBlock, vnBlink, '-', '+');
    //--Вывод bool в позицию 3,2------------------------------------------------------------------------
    if (!idLcdBit41.custom)  {RT_HW_Lcd_hd44780.setIdChar(idLcdBit41,   num_4, 2, 2, 'B', 2);} idLcdBit41.boolVal = vnBut;
                                                                                                RT_HW_Lcd_hd44780.printIdChar(idLcdBit41, vnBlock, vnBlink, '0', '1');
    //--Вывод char в позицию 3,2---------------------------------------------------------------------
    if (!idLcdChar41.custom) {RT_HW_Lcd_hd44780.setIdChar(idLcdChar41,  num_4, 3, 2, 'C', 5);} RT_HW_Lcd_hd44780.printIdChar(idLcdChar41, vnBlock, vnBlink, vChar);
    //--Вывод TXT_PGM--------------------------------------------------------------------------------
    if (!idLcdPGM41.custom)  {RT_HW_Lcd_hd44780.setIdText(idLcdPGM41,  num_4, 2, 1, 8, 10);}
    if (idLcdPGM41.dir == 1) {if (cntAgoPGM41 != cntNumTextPGM) {cntAgoPGM41 = cntNumTextPGM; textN41 = getNameStrPGM(cntNumTextPGM);idLcdPGM41.event.fresh = 1;}}
    RT_HW_Lcd_hd44780.printTextPGM(idLcdPGM41, vnBlock, vnBlink, 'C', textN41);
    //--Вывод TXT_STR--------------------------------------------------------------------------------
    if (!idLcdSTR41.custom)  { RT_HW_Lcd_hd44780.setIdText(idLcdSTR41,   num_4, 10, 1, 7, 10);}
    if (idLcdSTR41.dir == 1) {RT_HW_Lcd_hd44780.device.buff16 = RT_HW_Lcd_hd44780.CRC16_String(vStr);
                              if (crcAgoSTR41 != RT_HW_Lcd_hd44780.device.buff16) {crcAgoSTR41 = RT_HW_Lcd_hd44780.device.buff16; idLcdSTR41.event.fresh = 1;}}
    RT_HW_Lcd_hd44780.printTextSTR(idLcdSTR41, vnBlock, vnBlink, 'C', vStr);
    //-----------------------------------------------------------------------------------------------
  } //--END if (numFrdm == 18)
  //=================================================================================================
  //    Работа с  ADC,PWM,DAC и другими пинами (вызов 1 раз в 100ms)
  //=================================================================================================
  if (numFast == 1) {
    RT_HW_Base.pinReadADC(idADC, pinADC); vnADC = idADC.normal; vnMinusADC = -idADC.normal; vdADC = idADC.device; vFADC = vnADC * 5.0 / 4095; //--Чтение ADC;
    vnPWM = vnADC; RT_HW_Base.pinWritePWM(idPWM, pinPWM, vnPWM);  vdPWM = idPWM.device;                         //--Запись в PWM;
    vnDAC = vnADC; RT_HW_Base.pinWriteDAC(idDAC, pinDAC, vnDAC);  vdDAC = idDAC.device;                         //--Запись в DAC;
    RT_HW_Base.pinReadDIN(idBlock, (int8_t)pinBlock, 'U', 'Y', 0);   vnBlock = !idBlock.normal; //vdBlock=idBlock.device;     //--Чтение кнопки 1 (блокировка вывода на lcd);
    RT_HW_Base.pinReadDIN(idBlink, (int8_t)pinBlink, 'U', 'Y', 0);   vnBlink = idBlink.normal; //vdBlink=idBlink.device;     //--Чтение кнопки 2 (мерцание на lcd);
  };
  //=================================================================================================
  //   Чтение кнопки (с защитой от дребезга) и вывод на led (вызов 1 раз в 20 циклов loop() )
  //=================================================================================================
  if (numFrdm == 1) {
    RT_HW_Base.pinReadDIN(idBut, (int8_t)pinBut, 'U', 'Y', 2);  vnBut = idBut.normal; //vdBut=idBut.device;       //--Чтение кнопки but с защитой от дребезга(50*2=100vc);
    vnLed = vnBut; RT_HW_Base.pinWriteDOT(idLed, (int8_t)pinLed, vnLed, 'N');
  };                                      //--Запись на пин Led;
  //=================================================================================================
  //  Формирование символьной и строковой переменной (вызов 1 раз в 100ms)
  //=================================================================================================
  if (numSlow == 1) {
    //---------------------------------------------------
    if (++cntNsec >= 2) {cntNsec = 0;};
    //---------------------------------------------------
    vChar = 'A' + cntChar; if (++cntChar > 10) {cntChar = 0;}; //--Формирование символа 1 раз в сек;
    //----------------------------------------------------
    if (++cntDivStr > 2) {cntDivStr = 1; vStr = getTextSTR(cntStr);  
                          if (++cntStr > 6)         {cntStr = 0;}
                          if (++cntNumTextPGM > 6)  {cntNumTextPGM = 0;}}
  }//---if (numSlow == 1)
  //------------------------------------------------------------------------------------------------
} //--End loop;
