//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Коды идентификаторов архитектур контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_ARCH_ANON_ID=0,  		RT_HW_ARCH_AVR_ID,     		RT_HW_ARCH_SAM3_ID,     
      RT_HW_ARCH_ESP8266_ID, 		RT_HW_ARCH_ESP32_ID, 
      RT_HW_ARCH_STM32F1_ID, 		RT_HW_ARCH_STM32F4_ID, 		RT_HW_ARCH_STM32H7_ID};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Коды идентификаторов контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	  
enum {RT_HW_BOARD_ANON_ID=0, 		
      RT_HW_BOARD_AVR328_ID,		RT_HW_BOARD_MEGA2560_ID, 	
      RT_HW_BOARD_DUE_ID=10,
      RT_HW_BOARD_ESP8266_ID=20,		
	  RT_HW_BOARD_ESP32_ID=30,
	  RT_HW_BOARD_STM32F103C_ID=40,	RT_HW_BOARD_BLUEPILL_F103Cx_ID, RT_HW_BOARD_BLACKPILL_F103Cx_ID,
	  RT_HW_BOARD_STM32F103R_ID,	RT_HW_BOARD_STM32F103V_ID,	 	RT_HW_BOARD_STM32F103Z_ID,  
	  RT_HW_BOARD_STM32F401xx_ID=50,RT_HW_BOARD_BLACKPILL_F401CC_ID, 
	  RT_HW_BOARD_STM32F407Vx_ID,	RT_HW_BOARD_BLACK_F407Vx_ID,
	  RT_HW_BOARD_STM32F411xx_ID, 	RT_HW_BOARD_BLACKPILL_F411CE_ID, 
	  RT_HW_BOARD_STM32F746G_DISCOVERY_ID=60,
	  RT_HW_BOARD_STM32H743Vx_ID=70,RT_HW_BOARD_STM32H750Vx_ID	  
	  };  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		i2c: 1.Коды битов слова состояния(конфигурации); 
//			 2.Коды скоростей шины;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_I2C_STATE_INIT=0, RT_HW_I2C_STATE_SLAVE=1, RT_HW_I2C_STATE_BUSY=7};
enum {RT_HW_I2C_SPEED_LOW=  10000UL, RT_HW_I2C_SPEED_ST= 100000UL, 
	  RT_HW_I2C_SPEED_FM=  400000UL, RT_HW_I2C_SPEED_FM1=600000UL, RT_HW_I2C_SPEED_FM2= 600000UL,
	  RT_HW_I2C_SPEED_FMP=1000000UL, RT_HW_I2C_SPEED_HS=3400000UL, RT_HW_I2C_SPEED_UFM=5000000UL}; 
enum {RT_HW_I2C_MODE_LOW=0, RT_HW_I2C_MODE_ST, RT_HW_I2C_MODE_FM, RT_HW_I2C_MODE_FM1, RT_HW_I2C_MODE_FM2,
	  RT_HW_I2C_MODE_FMP,   RT_HW_I2C_MODE_HS, RT_HW_I2C_MODE_UFM}; 	  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						ИДЕНТИФИКАЦИЯ КОНТРОЛЛЕРОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----AVR328--------------------------------------------------------------------------------------
//#if !defined(RT_HW_BOARD_CODE) && (defined(ARDUINO_ARDUINO_NANO)) 
#if !defined(RT_HW_BOARD_DEFINED) && (defined(__AVR_ATmega328__) || defined (__AVR_ATmega328P__) || defined(__AVR_ATmega168__))	
#define      RT_HW_BOARD_DEFINED
#define 					    		  	RT_HW_BOARD_AVR328			//--Идентификатор платы;
#define RT_HW_ARCH_AVR													//--Идентификация архитектуры платы;
#endif	
//-----MEGA2560-------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(__AVR_ATmega2560__) || defined(__AVR_ATmega2561__))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_MEGA2560		//--Идентификатор платы;
#define RT_HW_ARCH_AVR													//--Идентификация архитектуры платы;
#endif			
//-----DUE------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(__SAM3X8E__) || defined(__SAM3A8C__) || defined(__SAM3A4C__))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_DUE				//--Идентификатор платы;
#define RT_HW_ARCH_SAM3					    							//--Идентификация архитектуры платы;
#endif
//-----ESP8266--------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_ARCH_ESP8266))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_ESP8266			//--Идентификатор платы;
#define RT_HW_ARCH_ESP8266												//--Идентификация архитектуры платы;
#endif
//-----ESP32---------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_ARCH_ESP32))
#define      RT_HW_BOARD_DEFINED 
#define 					    			RT_HW_BOARD_ESP32			//--Идентификатор платы;
#define RT_HW_ARCH_ESP32												//--Идентификация архитектуры платы;
#endif
//-----STM32F103Cx---------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED)  &&  (defined(ARDUINO_GENERIC_F103C8)   || defined(ARDUINO_GENERIC_F103CB))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_STM32F103C		//--Идентификатор платы;
#define RT_HW_ARCH_STM32F1												//--Идентификация архитектуры платы;
#endif
//-----STM32F103Rx---------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED)  &&  (defined(ARDUINO_GENERIC_F103R8)   || defined(ARDUINO_GENERIC_F103RB)\
  || defined(ARDUINO_GENERIC_F103RC) || defined(ARDUINO_GENERIC_F103RD)   || defined(ARDUINO_GENERIC_F103RE)\
  || defined(ARDUINO_GENERIC_F103RF) || defined(ARDUINO_GENERIC_F103RG))
#define 					    			RT_HW_BOARD_STM32F103R		//--Идентификатор платы;
#define RT_HW_ARCH_STM32F1												//--Идентификация архитектуры платы;
#endif
//-----STM32F103Vx---------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) &&   (defined(ARDUINO_GENERIC_F103V8)   || defined(ARDUINO_GENERIC_F103VB)\
  || defined(ARDUINO_GENERIC_F103VC) || defined(ARDUINO_GENERIC_F103VD)   || defined(ARDUINO_GENERIC_F103VE)\
  || defined(ARDUINO_GENERIC_F103VF) || defined(ARDUINO_GENERIC_F103VG))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_STM32F103V		//--Идентификатор платы; 
#define RT_HW_ARCH_STM32F1												//--Идентификация архитектуры платы;
#endif
//-----STM32F407x----------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_F407VG) || defined(ARDUINO_GENERIC_F407VE))
#define      RT_HW_BOARD_DEFINED
#define 					    			RT_HW_BOARD_STM32F407Vx		//--Идентификатор платы;
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//-----STM32F401x----------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && \
(defined(ARDUINO_GENERIC_F401RE) || defined(ARDUINO_GENERIC_F401RD) || defined(ARDUINO_GENERIC_F401RC)|| defined(ARDUINO_GENERIC_F401RB) \
||defined(ARDUINO_GENERIC_F401CE)|| defined(ARDUINO_GENERIC_F401CD) || defined(ARDUINO_GENERIC_F401CC)|| defined(ARDUINO_GENERIC_F401CB))
#define      RT_HW_BOARD_DEFINED
#define 					    	      	RT_HW_BOARD_STM32F401Cx		//--Идентификатор платы;
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//-----STM32F411x----------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && \
(defined(ARDUINO_GENERIC_F411RE) || defined(ARDUINO_GENERIC_F411RC) || defined(ARDUINO_GENERIC_F411CE)|| defined(ARDUINO_GENERIC_F411CC) \
||defined(ARDUINO_BLACKPILL_F411CE))
#define      RT_HW_BOARD_DEFINED 
#define 					    	      	RT_HW_BOARD_STM32F411Cx		//--Идентификатор платы; 
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//=================================================================================================
//-----BLUEPILL_F103CX---------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED)  &&  (defined(ARDUINO_BLUEPILL_F103C6) || defined(ARDUINO_BLUEPILL_F103C8) || defined(ARDUINO_BLUEPILL_F103CB))
#define      RT_HW_BOARD_DEFINED
#define 					    		RT_HW_BOARD_BLUEPILL_F103Cx	//--Идентификатор платы;
#define RT_HW_ARCH_STM32F1												//--Идентификация архитектуры платы;
#endif
//-----BLACKPILL_F103CX---------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED)  &&  (defined(ARDUINO_BLACKPILL_F103C8) || defined(ARDUINO_BLACKPILL_F103CB))
#define      RT_HW_BOARD_DEFINED
#define 					    		RT_HW_BOARD_BLACKPILL_F103Cx	//--Идентификатор платы;
#define RT_HW_ARCH_STM32F1												//--Идентификация архитектуры платы;
#endif
//-----BLACKPILL_F401CC----------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACKPILL_F401CC))
#define      RT_HW_BOARD_DEFINED
#define 					    	      RT_HW_BOARD_BLACKPILL_F401CC	//--Идентификатор платы;
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//-----BLACKPILL_F411CE----------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACKPILL_F411CE))
#define      RT_HW_BOARD_DEFINED
#define 					    	      RT_HW_BOARD_BLACKPILL_F411CE	//--Идентификатор платы;
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//-----BLACK_F407XX--------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) &&  (defined(ARDUINO_BLACK_F407VE)  || defined(ARDUINO_BLACK_F407VG))
#define      RT_HW_BOARD_DEFINED
#define 					    	        RT_HW_BOARD_BLACK_F407Vx//--Идентификатор платы;
#define RT_HW_ARCH_STM32F4												//--Идентификация архитектуры платы;
#endif
//-----STM32F746G-DISCOVERY-------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) &&  (defined(ARDUINO_STM32F746G_DISCOVERY) || defined(ARDUINO_DISCO_F746NG) || defined(STM32F46G_DISCOVERY_ECOINS) )
#define      RT_HW_BOARD_DEFINED
#define 					    	       RT_HW_BOARD_STM32F746G_DISCOVERY		//--Идентификатор платы;
#define RT_HW_ARCH_STM32F7														//--Идентификация архитектуры платы;
#endif

//====АРХИТЕКТУРА ESP8266============================================================================
#if defined(RT_HW_ARCH_ESP8266) ||  defined(RT_HW_ARCH_ESP32)
#define RT_HW_ARCH_ESP
#endif
//====АРХИТЕКТУРА STM32============================================================================
#if defined(RT_HW_ARCH_STM32F1) ||  defined(RT_HW_ARCH_STM32F4) || defined(RT_HW_ARCH_STM32F7) || defined(RT_HW_ARCH_STM32H7)
#define RT_HW_ARCH_STM32
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++