
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Архитектура AVR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_AVR)
#define RT_HW_ARCH_CODE				RT_HW_ARCH_AVR_ID
#define RT_HW_ARCH_NAME				"AVR"
#define RT_HW_DATE_TYPE 			uint8_t	
struct  RT_HW_PIN_DIR_ID {uint8_t pin; uint8_t dir; uint16_t mode; uint8_t bit; volatile uint8_t *base;};	
							
//----------------------1.1.Дополнительные библиотеки.
#include <SoftwareSerial.h>										//--Программный UART;
//----------------------1.2.Макросы для работы c пинами через функции WIRING-----------------------  
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  		OUTPUT			//--Дискретный выход с открытым выходом;
//----------------------1.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p) 	    	id.pin=p; id.bit=digitalPinToBitMask(p); id.base=portInputRegister(digitalPinToPort(p));
#define RT_HW_PIN_DIR_MODE_INPUT(id)        *((id.base)+(1)) &=~id.bit; *((id.base)+(2))&=~id.bit; 
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    *((id.base)+(1)) &=~id.bit;  *((id.base)+(2))|= id.bit;
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    *((id.base)+(1)) |= id.bit;
#define RT_HW_PIN_DIR_READ(id)           (((*((id.base)+(0))) & id.bit) ? (1) : (0)); 
#define RT_HW_PIN_DIR_WRITE(id,val) if(val){*((id.base)+(2)) |= id.bit;} else{*((id.base)+(2)) &= ~id.bit;};
#define RT_HW_PIN_DIR_WRITE_LOW(id)         *((id.base)+(2)) &= ~id.bit;
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        *((id.base)+(2)) |= id.bit;
//-------------------------------------------------------------------------------------------------	
#endif			
//-------------------------------------------------------------------------------------------------	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Архитектура DUE
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_SAM3)
#define RT_HW_ARCH_CODE				RT_HW_ARCH_SAM3_ID
#define RT_HW_ARCH_NAME				"SAM3"
#define RT_HW_DATE_TYPE 			uint32_t	
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;}; 
//----------------------2.1.Подключение библиотек--------------------------------------------------
//----------------------2.2.Макросы для работы c пинами через функции WIRING----------------------- 
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  		OUTPUT			//--Дискретный выход с открытым выходом;
//----------------------2.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p) 	    	id.pin=p; id.bit=digitalPinToBitMask(p); id.base=(&(digitalPinToPort(p)->PIO_PER));
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT); 				// *((id.base)+(5))= id.bit;   
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);		// *((id.base)+(6))= id.bit;  
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    *((id.base)+(4))= id.bit;
#define RT_HW_PIN_DIR_READ(id)           	(((*((id.base)+(15))) & id.bit) ? (1) : (0)); 
#define RT_HW_PIN_DIR_WRITE(id,val) 		if(val){*((id.base)+(12))= id.bit;} else{*((id.base)+(13))= id.bit;};
#define RT_HW_PIN_DIR_WRITE_LOW(id)         *((id.base)+(13))= id.bit;
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        *((id.base)+(12))= id.bit;
//-------------------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------------------	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Архитектура ESP8266
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_ESP8266)
#define RT_HW_ARCH_CODE 			RT_HW_ARCH_ESP8266_ID
#define RT_HW_ARCH_NAME				"ESP8266"
#define RT_HW_DATE_TYPE 			uint32_t									
struct  RT_HW_PIN_DIR_ID{uint32_t pin; uint32_t dir; uint16_t mode; uint32_t GPFFS_pin; uint32_t LEFT_PIN; uint32_t LEFT_GPCI; uint32_t LEFT_GPCD; uint32_t LEFT_GPFPU;};
enum{pD0=16, pD1=5, pD2=4, pD3=0, pD4=2, pD5=14, pD6=12, pD7=13, pD8=15, pRX=3, pTX=1, pA0=17};
//----------------------3.1.Подключение библиотек--------------------------------------------------
#include <SoftwareSerial.h>		
//----------------------3.2.Макросы для работы c пинами через функции WIRING----------------------- 
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  		OUTPUT			//--Дискретный выход с открытым выходом;
//----------------------3.3.Макросы прямого управления пинами--------------------------------------
static inline __attribute__((always_inline))		//--Чтение дискретного пина
bool RT_HW_BASE_digitalReadFast(RT_HW_PIN_DIR_ID &id) {if(id.pin < 16){return GPIP(id.pin);} else if(id.pin == 16){return GP16I & 0x01;} return 0;};
#define RT_HW_PIN_DIR_SET_ID(id,p)    id.pin=p; id.GPFFS_pin=GPFFS(GPFFS_GPIO(id.pin)); id.LEFT_PIN=(1<<id.pin); id.LEFT_GPCI=(0xF<<GPCI); id.LEFT_GPCD=(1<<GPCD); id.LEFT_GPFPU=(1<<GPFPU);
#define RT_HW_PIN_DIR_MODE_INPUT(id)  GPF(id.pin)=id.GPFFS_pin; GPEC=id.LEFT_PIN; GPC(id.pin)=(GPC(id.pin) & id.LEFT_GPCI) | (id.LEFT_GPCD);
#define RT_HW_PIN_DIR_MODE_PULLUP(id) GPF(id.pin)=id.GPFFS_pin; GPEC=id.LEFT_PIN; GPC(id.pin)=(GPC(id.pin) & id.LEFT_GPCI) | (id.LEFT_GPCD);  GPF(id.pin) |=id.LEFT_GPFPU;
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) GPF(id.pin)=id.GPFFS_pin; GPC(id.pin)=GPC(id.pin) & id.LEFT_GPCI; GPES = id.LEFT_PIN;
#define RT_HW_PIN_DIR_READ(id)        RT_HW_BASE_digitalReadFast(id);
#define RT_HW_PIN_DIR_WRITE(id,val)   if(val) GPOS=id.LEFT_PIN; else GPOC=id.LEFT_PIN;
#define RT_HW_PIN_DIR_WRITE_LOW(id,val)                              GPOC=id.LEFT_PIN;
#define RT_HW_PIN_DIR_WRITE_HIGH(id,val)      GPOS=id.LEFT_PIN;
//-------------------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------------------
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Архитектура ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_ESP32) 
#define RT_HW_ARCH_CODE 			RT_HW_ARCH_ESP32_ID
#define RT_HW_ARCH_NAME				"ESP32"
#define RT_HW_DATE_TYPE 			uint32_t
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit;}; //--Структура для прямого управления пинами
//----------------------4.1.Подключение библиотек--------------------------------------------------
#include "esp32-hal-ledc.h"										//--Библиотека для работы с PWM и LED;	
#include <driver/rtc_io.h>										//--
//----------------------4.2.Макросы для работы c пинами через функции WIRING----------------------- 
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT_PULLDOWN	//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  	 OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым выходом;
//----------------------4.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p) 	        id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,1);
//-------------------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------------------
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Архитектура STM32F1
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_STM32F1) 
#define RT_HW_ARCH_CODE 			RT_HW_ARCH_STM32F1_ID
#define RT_HW_ARCH_NAME				"STM32F1"
#define RT_HW_DATE_TYPE 			uint32_t
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;}; //--Структура для прямого управления пинами
//----------------------5.1.Подключение библиотек--------------------------------------------------
//#include <avr/pgmspace.h>										//--Работа с PROGMEM;
#include "usbd_cdc_if.h"										//--Для работы с USB_CDC
//----------------------5.2.Макросы для работы c пинами через функции WIRING-----------------------
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT_PULLDOWN	//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT_ANALOG	//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  	 OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым выходом;
//----------------------5.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p)	  id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)  pinMode(id.pin,INPUT);		//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_PULLUP(id) pinMode(id.pin,INPUT_PULLUP);	//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) pinMode(id.pin,OUTPUT);		//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_OUTPUT_PP, GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_READ(id)        digitalRead(id.pin);			//digitalReadFast((PinName)id.pin);  //digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val)   digitalWrite(id.pin,val);		//if(val){digitalWriteFast((PinName)id.pin,HIGH);} else {digitalWriteFast((PinName)id.pin,LOW);} 
#define RT_HW_PIN_DIR_WRITE_LOW(id)   digitalWrite(id.pin,0);		//digitalWriteFast((PinName)id.pin, LOW); 	//digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)  digitalWrite(id.pin,l);		//digitalWriteFast((PinName)id.pin, HIGH);	//digitalWrite(id.pin,1);
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6.Архитектура STM32F4
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_STM32F4)
#define RT_HW_ARCH_CODE 			RT_HW_ARCH_STM32F4_ID
#define RT_HW_ARCH_NAME				"STM32F4"
#define RT_HW_DATE_TYPE 			uint32_t
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;};
//----------------------6.1.Подключение библиотек--------------------------------------------------
//#include <avr/pgmspace.h>										//--Работа с PROGMEM;
#include "usbd_cdc_if.h"										//--Для работы с USB_CDC
//----------------------6.2.Макросы для работы c пинами через функции WIRING-----------------------
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT_PULLDOWN	//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT_ANALOG	//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  	 OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым выходом;
//----------------------6.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p) 	        id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);	//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_OUTPUT_PP, GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);			//digitalReadFast((PinName)id.pin);  //digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);		//if(val){digitalWriteFast((PinName)id.pin, HIGH);} else {digitalWriteFast((PinName)id.pin,LOW);} 
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);			//digitalWriteFast((PinName)id.pin, LOW); 	//digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,l);			//digitalWriteFast((PinName)id.pin, HIGH);	//digitalWrite(id.pin,1);
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6.Архитектура STM32F7
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_STM32F7)
#define RT_HW_ARCH_CODE 			RT_HW_ARCH_STM32F7_ID
#define RT_HW_ARCH_NAME				"STM32F7"
#define RT_HW_DATE_TYPE 			uint32_t
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;};
//----------------------6.1.Подключение библиотек--------------------------------------------------
//#include <avr/pgmspace.h>										//--Работа с PROGMEM;
#include "usbd_cdc_if.h"										//--Для работы с USB_CDC
//----------------------6.2.Макросы для работы c пинами через функции WIRING-----------------------
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT_PULLDOWN	//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT_ANALOG	//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  	 OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым выходом;
//----------------------6.3.Макросы прямого управления пинами--------------------------------------
#define RT_HW_PIN_DIR_SET_ID(id,p) 	        id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);	//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_OUTPUT_PP, GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);			//digitalReadFast((PinName)id.pin);  //digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);		//if(val){digitalWriteFast((PinName)id.pin, HIGH);} else {digitalWriteFast((PinName)id.pin,LOW);} 
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);			//digitalWriteFast((PinName)id.pin, LOW); 	//digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,l);			//digitalWriteFast((PinName)id.pin, HIGH);	//digitalWrite(id.pin,1);
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							9. Идентификация контроллера ANON (неопознанный контроллер)
//*************************************************************************************************
#if !defined(RT_HW_ARCH_CODE)  										//--Плата ANON;
#define RT_HW_ARCH_ANON												//--Идентификация архитектуры платы;
#define RT_HW_ARCH_CODE						RT_HW_ARCH_ANON_ID
#define RT_HW_ARCH_NAME						"ANON"
#define RT_HW_DATE_TYPE 					uint16_t	
struct  RT_HW_PIN_DIR_ID {uint16_t pin; uint16_t dir; uint16_t mode; uint16_t bit; volatile uint16_t *base;}; 
//----------------------1.1.Подключение библиотек--------------------------------------------------
//#include <avr/pgmspace.h>										//--Работа с PROGMEM;
//----------------------1.2.Макросы для работы c пинами через функции WIRING----------------------- 
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
//---Расширение STM32----//
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  	 	OUTPUT			//--Дискретный выход с открытым выходом;
//----------------------1.3.Макросы прямого управления пинами--------------------------------------	
#define RT_HW_PIN_DIR_SET_ID(id,p) 	        id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);			
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val); 
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,l);
//-------------------------------------------------------------------------------------------------
#endif

//#if defined(RT_HW_ARCH_STM32) 
//#include "usbd_cdc_if.h"
//#endif
//**************************************************************************************************
/*
#define INPUT         0x0
#define OUTPUT              0x1
#define INPUT_PULLUP        0x2
///STM32 extension ///
#define INPUT_FLOATING      INPUT
#define INPUT_PULLDOWN      0x3
#define INPUT_ANALOG        0x4
#define OUTPUT_OPEN_DRAIN   0x5
*/

//=================================================================================================