//*************************************************************************************************
//							1.Контроллеры типа Arduino UNO,Nano
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && defined(RT_HW_BOARD_AVR328)	
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_AVR328_ID	//--Идентификация платы; 
#define RT_HW_BOARD_NAME		           			 "AVR328"	//--Наименование платы; 									
//-----Параметры контроллера общие-----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=22,	RT_HW_FCPU=16, RT_HW_VCC=5000};
enum{RT_HW_MEM_ROM=32,  	RT_HW_MEM_RAM=2, 	RT_HW_MEM_EEPROM=1, RT_HW_MEM_RTC=0, RT_HW_MEM_EXT_RAM=0};
enum{RT_HW_UARTS_RX=8, 		RT_HW_UARTS_TX=9}; //--Пины для SoftSerial задаются из особенностей библиотеки <SoftwareSerial.h>		
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UARTS
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_SPI0
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={10,13,           RT_HW_PGM_END};  //--Пины->control,led; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={10,3,4, 		   RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={         	   	   RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={ 8,10,           RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={          	   RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={ 0,18,19,RT_HW_I2C_MODE_FM,			RT_HW_PGM_END}; // Адрес (=0 master,>0 slave),SDA,SCL,mode Speed;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={10,11,12,13,							RT_HW_PGM_END}; //--SPI->SS,MOSI,MISO,SCK; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={0,1,									RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={RT_HW_UARTS_RX,RT_HW_UARTS_TX,		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={										RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={0 , 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={14,15,16,17,18,19,20,21,									RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={															RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,		RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={3,5,6,9,10,11,											RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={															RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={2,3,														RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={															RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={	    			RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={5,6,4,         	RT_HW_PGM_END};	// PWM0,PWM1,led1,led2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={20,21,        	RT_HW_PGM_END};	// A0,A1,btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={          		RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={2,2,3,			RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={14,15,16,17,		RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 		
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={					RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={					RT_HW_PGM_END};	// Пины программного SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={39,62,32,33,		RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							1.Контроллер типа MEGA2560
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && defined(RT_HW_BOARD_MEGA2560)	
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_MEGA2560_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "MEGA2560"	    //--Наименование платы;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_FCPU=16, 		RT_HW_VCC=5000, 	RT_HW_SIZE_SRAM=8,  RT_HW_SIZE_FLASH=256};
enum{RT_HW_MEM_ROM=256,  	RT_HW_MEM_RAM=8, 	RT_HW_MEM_EEPROM=4, RT_HW_MEM_RTC=0, 	RT_HW_MEM_EXT_RAM=0};
enum{RT_HW_UARTS_RX=68, 	RT_HW_UARTS_TX=69}; 
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_UART3
#define RT_HW_PERMIT_UARTS
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_SPI0
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   	RT_HW_PGM_END};  // SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={42,13,			RT_HW_PGM_END};  // Pins->control,led; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={10,3,4,			RT_HW_PGM_END};  // ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={0,  				RT_HW_PGM_END};  // TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={8,10,				RT_HW_PGM_END};  // PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={0,				RT_HW_PGM_END};  // DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={ 0,20,21,RT_HW_I2C_MODE_FM,	RT_HW_PGM_END}; // Адрес (=0 master,>0 slave),SDA,SCL,mode Speed;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={53,51,50,52, 					RT_HW_PGM_END}; // SPI->SS,MOSI,MISO,SCK;  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={0,1,19,18,17,16,15,14, 		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={68,69,				 		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={								RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={								RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={								RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={								RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										  16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										  32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										  48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,
										  64,65,66,67,68,69,								RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										  16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										  32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										  48,49,50,51,52,53,								RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,	RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={													RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										  16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										  32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										  48,49,50,51,52,53, 								RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={ 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,44,45,46,		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={													RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={ 2, 3,18,19,20,21,								RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={													RT_HW_PGM_END};		
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={43,44,45,			RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={ 5, 6,10,11,      RT_HW_PGM_END};	// PWM0,PWM1,led1,led2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={54,55, 8, 9,      RT_HW_PGM_END};	// A0,A1,btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={          		RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={ 4, 7, 3,			RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={46,47,48,49,		RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={32,33,34,35,36,37,RT_HW_PGM_END};	// LCD HD44780 for bus4;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={38,39,40,41,		RT_HW_PGM_END};	// Soft SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={39,62,32,33,		RT_HW_PGM_END}; // lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************

