//*************************************************************************************************
//							1.Контроллеры типа ESP8226
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && defined(RT_HW_BOARD_ESP8266)	
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_ESP8266_ID	//--Идентификация платы; 
#define RT_HW_BOARD_NAME		           			 "ESP8266"	//--Наименование платы; 									
//-----Параметры контроллера общие-----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=18,	RT_HW_FCPU=80, 		RT_HW_VCC=3300};
enum{RT_HW_MEM_ROM=0,  		RT_HW_MEM_RAM=80, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=0, RT_HW_MEM_EXT_RAM=4000};
enum{RT_HW_UARTS_RX=pD7,    RT_HW_UARTS_TX=pD8};
enum{RT_HW_I2C0_FREQ=100,	RT_HW_I2C1_FREQ=100,RT_HW_I2C2_FREQ=100};   
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UARTS
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_SPI0
#define RT_HW_PERMIT_WFI
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			 RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={pD0,pD4, 		 RT_HW_PGM_END};  //--Пины->control,led; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={10,3,4, 		 RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={          	 RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={10,10,         RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={          	 RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={0,pD2,pD1,RT_HW_I2C_MODE_ST,			RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={pD8,pD7,pD6,pD5,						RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={pRX,pTX,								RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={RT_HW_UARTS_RX, RT_HW_UARTS_TX,		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={										RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={										RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={pD0,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8,pRX,pTX,pA0,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={ -1,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8,pRX,pTX,		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={pA0,												RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={													RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={pD0,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8, -1,-1,		RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={ -1,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8, -1,-1,		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={													RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={ -1,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8, -1,-1,		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={pD0,pD1,pD2,pD3,pD4,pD5,pD6,pD7,pD8,pRX,pTX,pA0,	RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={	    		RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={pD8,-1,pD0,   RT_HW_PGM_END};	// PWM0, PWM1, led,dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={pA0,-1,pD4,   RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={          	RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={			   	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={				RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={				RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={				RT_HW_PGM_END};	// Пины программного SPI;		
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={39,62,32,33,	RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
