//*************************************************************************************************
//							1.Контроллер типа STM32F103C
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && (defined(RT_HW_BOARD_STM32F103C)	 || defined(RT_HW_BOARD_BLUEPILL_F103Cx) || defined(RT_HW_BOARD_BLACKPILL_F103Cx))
#if 	defined(RT_HW_BOARD_BLUEPILL_F103Cx)
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_BLUEPILL_F103Cx_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "BLUEPILL_103Cx"	    //--Наименование платы;
enum{RT_HW_MEM_ROM=128,  RT_HW_MEM_RAM=20, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=84, RT_HW_MEM_EXT_RAM=0};
#elif 	defined(RT_HW_BOARD_BLACKPILL_F103Cx)
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_BLACKPILL_F103Cx_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "BLACKPILL_103Cx"	    //--Наименование платы;
enum{RT_HW_MEM_ROM=128,  	RT_HW_MEM_RAM=20, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=84, RT_HW_MEM_EXT_RAM=0};
#else
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_STM32F103C_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "STM32F103Cx"	    //--Наименование платы;
enum{RT_HW_MEM_ROM=128,  	RT_HW_MEM_RAM=20, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=84, RT_HW_MEM_EXT_RAM=0};
#endif
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=35,	RT_HW_FCPU=72, 		RT_HW_VCC=3300}; 
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_UART3
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_I2C1
#define RT_HW_PERMIT_SPI0
#define RT_HW_PERMIT_SPI1
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={12,4,3,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={16,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={					RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={PB5,PC13,									RT_HW_PGM_END};  //--Пины->control,led; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={ 0,PB7, PB6,  RT_HW_I2C_MODE_FM,
										   0,PB11,PB10, RT_HW_I2C_MODE_FM, RT_HW_PGM_END}; //--SDA,SCL,Freq(2 байта); 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={PA4, PA7, PA6, PA5, PB12,PB15,PB14,PB13,	RT_HW_PGM_END}; //--SS,MOSI,MISO,SCK;  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={PA12,PA11,PA10,PA9, PA3, PA2, PB11,PB10,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={ PB8, PB9,				 		    	RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={											RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={											RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
										  PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  -1,  -1,  -1,PC13,PC14,PC15,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  -1,  -1,  -1,  -1,  -1,  -1,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PB0,PB1,		  					RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={						 												RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  -1,  -1,  -1,PC13,  -1,  -1,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={PA0,PA1,PA2,PA3,PA6,PA7,PA8,PA9,PA10,PB0,PB1,PB6,PB7,PB8,PB9,			RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={																		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,  -1,  -1,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PB0,PB1,PB5,PC13,PC14,PC15,			RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={						RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={PA2,  -1,PB0,			RT_HW_PGM_END};	// PWM0, PWM1, led, dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={PA0, PA1,PB1,			RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={         				RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={PB8, PB9, PA8, 	    RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={PB12,PB13,PB14,PB15,	RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={						RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={						RT_HW_PGM_END};	// Пины программного SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={63,62,32,33,			RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;								   
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							2.Контроллер типа STM32F103R
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && (defined(RT_HW_BOARD_STM32F103R))	
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_STM32F103R_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "STM32F103Rx"	    //--Наименование платы;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=51,	RT_HW_FCPU=72, 		RT_HW_VCC=3300};
enum{RT_HW_MEM_ROM=512,  	RT_HW_MEM_RAM=64, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=84, RT_HW_MEM_EXT_RAM=0};
enum{RT_HW_I2C0_FREQ=400,	RT_HW_I2C1_FREQ=400,RT_HW_I2C2_FREQ=400};   
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_UART3
#define RT_HW_PERMIT_UART4
#define RT_HW_PERMIT_UART5
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_I2C1
#define RT_HW_PERMIT_SPI0
#define RT_HW_PERMIT_SPI1
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={12,4,3,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={16,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={					RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={PC2,PB11,PC13,							RT_HW_PGM_END}; //--Пины->control,led,user_BTN; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={ 0,PB7, PB6,  RT_HW_I2C_MODE_FM,
										   0,PB11,PB10, RT_HW_I2C_MODE_FM, RT_HW_PGM_END}; //--SDA,SCL,Freq(2 байта); 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={PA4, PA7, PA6, PA5, PB12,PB15,PB14,PB13,	RT_HW_PGM_END}; //--SS,MOSI,MISO,SCK;  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={PA12,PA11,PA10,PA9, PA3, PA2, PB11,PB10,PC11,PC10,PD2,PC12,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={ PB8, PB9,				 		    	RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={											RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={											RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
										  PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,											 				RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, -1, -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,											 				RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PB0,PB1,PC0,PC1,PC2,PC3,PC4,PC5,  RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={						 												RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,											 				RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={PA0,PA1,PA2,PA3,PA6,PA7,PA8,PA9,PA10,PB0,PB1,PB6,PB7,PB8,PB9,			RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={PA3,PA4,																RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,  -1,  -1,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PB0,PB1,PB5,PC4,PC5,PB0,PB1,PB5,
										  PC13,PC14,PC15,														RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={PC3,PC4,PC5,			RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={PA4, -1,PB0,			RT_HW_PGM_END};	// PWM0, PWM1, led, dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={PA0, PA1,PB1,			RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={         				RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={PB8, PB9, PA8, 	 	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={PB12,PB13,PB14,PB15,	RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={						RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={						RT_HW_PGM_END};	// Пины программного SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={63,62,32,33,			RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif

//*************************************************************************************************
//							3.Контроллер типа STM32F103V
//*************************************************************************************************
#if !defined(RT_HW_BOARD_CODE) && (defined(RT_HW_BOARD_STM32F103V))	
#define RT_HW_BOARD_CODE				  RT_HW_BOARD_STM32F103V_ID	//--Идентификация платы;  
#define RT_HW_BOARD_NAME		           			 "STM32F103Vx"	    //--Наименование платы;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=80,	RT_HW_FCPU=72, 		RT_HW_VCC=3300};
enum{RT_HW_MEM_ROM=512,  	RT_HW_MEM_RAM=64, 	RT_HW_MEM_EEPROM=0, RT_HW_MEM_RTC=84, RT_HW_MEM_EXT_RAM=0};
enum{RT_HW_I2C0_FREQ=400,	RT_HW_I2C1_FREQ=400,RT_HW_I2C2_FREQ=400};   
//-----Параметры i2c-------------------------------------------------------------------------------	
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_UART3
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_I2C1
#define RT_HW_PERMIT_SPI0
#define RT_HW_PERMIT_SPI1
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={12,4,3,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={16,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={					RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={PC2,PB11,PC13,							RT_HW_PGM_END}; //--Пины->control,led,user_BTN; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={ 0,PB7, PB6,  RT_HW_I2C_MODE_FM,
										   0,PB11,PB10, RT_HW_I2C_MODE_FM, RT_HW_PGM_END}; //--SDA,SCL,Freq(2 байта); 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={PA4, PA7, PA6, PA5, PB12,PB15,PB14,PB13,	RT_HW_PGM_END}; //--SS,MOSI,MISO,SCK;  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={PA12,PA11,PA10,PA9, PA3, PA2, PB11,PB10,PC11,PC10,PD2,PC12,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={ PB8, PB9,				 		    	RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={				 							RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={											RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={											RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
										  PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
										  PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1,-1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
										  PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PB0,PB1,PC0,PC1,PC2,PC3,PC4,PC5,  RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={						 												RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
										  PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={PA0,PA1,PA2,PA3,PA6,PA7,PA8,PA9,PA10,PB0,PB1,PB6,PB7,PB8,PB9,			RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={PA3,PA4,																RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,  -1,  -1,PA15,
										  PB0,PB1, -1,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
										  PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
										  PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
										  PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PB0,PB1,PB5,PC4,PC5,PB0,PB1,PB5,
										  PC13,PC14,PC15,														RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={PC3,PC4,PC5,			RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={PA4, -1,PB0,			RT_HW_PGM_END};	// PWM0, PWM1, led, dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={PA0, PA1,PB1,			RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={         				RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={PB8, PB9, PA8, 	 	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={PB12,PB13,PB14,PB15,	RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={						RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={						RT_HW_PGM_END};	// Пины программного SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={63,62,32,33,			RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
