 
//=================================================================================================

//*************************************************************************************************
//							1.1 Контроллеры типа Arduino UNO,Nano
//*************************************************************************************************
#if defined(RT_HW_BOARD_AVR328)	
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=22,	RT_HW_FCPU=16,    	RT_HW_LED_BUILTIN=13,	RT_HW_VCC=5000, 	RT_HW_SIZE_SRAM=2,   RT_HW_SIZE_FLASH=32};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4,		RT_HW_ADC_NULL=3,		
	 RT_HW_PWM_DEPTH=8,		RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c---------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=18, RT_HW_I2C_SCL=19, RT_HW_I2C_FREQ=400};
//enum{RT_HW_I2C_FREQ_SLOW=100, RT_HW_I2C_FREQ_FAST=400, RT_HW_I2C_FREQ_QUICK=800, RT_HW_I2C_FREQ_DEFAULT=400};
//------Параметры SPI---------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=10,	RT_HW_SPI_MOSI=11,	RT_HW_SPI_MISO=12,	RT_HW_SPI_SCK=13};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UARTS
enum{RT_HW_UART_RX=0,	RT_HW_UART_TX=1, 	RT_HW_UARTS_RX=8,	RT_HW_UARTS_TX=9};
//-----Макросы контроля номеров пинов--------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<22)               ? (p):(-1)) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((p)>=2 && (p)<22       ? (p):(-1)) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=14) && ((p)<22)  ? (p):(-1)) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Наличие пина типа DOT
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1))	//--Наличие пина типа DIR(прямое управление)
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Наличие у пина прерывания
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							1.2 Контроллер типа MEGA2560
//*************************************************************************************************
#if defined(RT_HW_BOARD_MEGA2560)																
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_FCPU=16,      RT_HW_LED_BUILTIN=13, RT_HW_VCC=5000, 	RT_HW_SIZE_SRAM=8,  RT_HW_SIZE_FLASH=256};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4,	  RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c---------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=20, RT_HW_I2C_SCL=21, RT_HW_I2C_FREQ=400};
//------Параметры SPI---------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=53,		RT_HW_SPI_MOSI=51,	RT_HW_SPI_MISO=50,	RT_HW_SPI_SCK=52};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
#define RT_HW_UARTS
enum{RT_HW_UART_RX=0,   RT_HW_UART_TX=1,   RT_HW_UARTS_RX=68, RT_HW_UARTS_TX=69, 
	 RT_HW_UART1_RX=19, RT_HW_UART1_TX=18, RT_HW_UART2_RX=17, RT_HW_UART2_TX=16, RT_HW_UART3_RX=15, RT_HW_UART3_TX=14};
//------Макросы контроля номеров пинов-------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<70)               ? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=54) && ((p)<70)  ? (p):(-1)) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<54)  ? (p):(-1)) //--Наличие пина типа DIR(прямое управление)
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Наличие у пина прерывания
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//										2. ПЛАТФОРМА ARDUINO DUE
//*************************************************************************************************
#if defined(RT_HW_BOARD_DUE)
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_FCPU=84,		RT_HW_LED_BUILTIN=13, RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=96,   RT_HW_SIZE_FLASH=512};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,    RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=12, RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c---------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=20, RT_HW_I2C_SCL=21, RT_HW_I2C_FREQ=400};
//------Параметры SPI---------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=53,    RT_HW_SPI_MOSI=51,	RT_HW_SPI_MISO=50,	RT_HW_SPI_SCK=52};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
enum{RT_HW_UART_RX=0,	RT_HW_UART_TX=1,   
	 RT_HW_UART1_RX=19, RT_HW_UART1_TX=18, RT_HW_UART2_RX=17, RT_HW_UART2_TX=16, RT_HW_UART3_RX=15, RT_HW_UART3_TX=14};
//------Макросы контроля номеров пинов-------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<RT_HW_PIN_QNT_MAX)? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=54) && ((p)<70)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (((p)==67)              ? (p):(-1))	//--Пин типа DAC (пин 66 не работает из-за ошибок в библиотеке IDE);
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<54)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление);
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Номер прерывания по номеру пина;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//										3. ПЛАТФОРМА  ESP8266
//*************************************************************************************************
#if defined(RT_HW_BOARD_ESP8266) 		
//------Параметры контроллера общие----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=18,	RT_HW_FCPU=80,    	RT_HW_LED_BUILTIN=2, 	RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=128,RT_HW_SIZE_FLASH=4000};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4,		RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=10,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
//enum{RT_HW_I2C_SDA=4, RT_HW_I2C_SCL=5, RT_HW_I2C_FREQ_SLOW=100, RT_HW_I2C_FREQ_FAST=400, RT_HW_I2C_FREQ_QUICK=400, RT_HW_I2C_FREQ_DEFAULT=100};
enum{RT_HW_I2C_SDA= 4, RT_HW_I2C_SCL= 5, RT_HW_I2C_FREQ=100};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=15,	RT_HW_SPI_MOSI=13,	RT_HW_SPI_MISO=12,	RT_HW_SPI_SCK=14};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
enum{RT_HW_UART_RX=13,	RT_HW_UART_TX=15};
//------Параметры Wi-Fi----------------------------------------------------------------------------
#define RT_HW_WIFI
//------Макросы контроля номеров пинов-------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(!(((p)>=6) && ((p)<=11))) 						//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  (((p) < 18) && RT_HW_PIN_BLOCK_1 ? (p) : -1) 	//--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)  	//--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  ((p) == 17     		   	         ? (p) : -1)	//--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p) < 17) && RT_HW_PIN_BLOCK_1 ? (p) : -1) 	//--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)											//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)											//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)    //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)  	//--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									4.ПЛАТФОРМА  ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_ESP32) 
//------Параметры контроллера общие----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=40,	RT_HW_FCPU=160,    	RT_HW_LED_BUILTIN=2, 	RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=520,RT_HW_SIZE_FLASH=448};
enum{RT_HW_SYS_DEPTH=12,    RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=10,		RT_HW_ADC_NULL=10,	RT_HW_PWM_DEPTH=12, RT_HW_DAC_DEPTH=8}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
//enum{RT_HW_I2C_SDA=21, RT_HW_I2C_SCL=22, RT_HW_I2C_FREQ_SLOW=100, RT_HW_I2C_FREQ_FAST=400, RT_HW_I2C_FREQ_QUICK=800, RT_HW_I2C_FREQ_DEFAULT=400};
enum{RT_HW_I2C_SDA=21, RT_HW_I2C_SCL=22, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=5,     RT_HW_SPI_MOSI=23,		RT_HW_SPI_MISO=19,		RT_HW_SPI_SCK=18};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART2
enum{RT_HW_UART_RX=3,	RT_HW_UART_TX=1,   RT_HW_UART2_RX=16, RT_HW_UART2_TX=17};
//------Параметры Wi-Fi----------------------------------------------------------------------------
#define RT_HW_WIFI
//------Параметры BlueTooth------------------------------------------------------------------------
#define RT_HW_BT
//------Макросы контроля номеров пинов-------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  ((p) < 40	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((p) < 40                               ? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  ((((p) >=32) && ((p) <=39))   		   	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  ((p) < 34	                            ? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  ((p) < 34                               ? (p) : -1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  ((((p)==25)  || ((p)==26))        		? (p) : -1)	//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  ((p)==4  || (p)==0 ||(p)==2 || (p)==4  || (p)==15 || (p)==13 \
              || (p)==12 || (p)==14 || (p)==27 || (p)==33 || (p)==32    ? (p) : -1) //--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  ((p) < 34	                            ? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  ((p) < 34	                            ? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									5.1. ПЛАТФОРМА STM32 - STM32F103C
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F103C)     		
//------Параметры контроллера общие----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=35,	RT_HW_FCPU=72,		RT_HW_LED_BUILTIN=32, 	RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=20,RT_HW_SIZE_FLASH=128};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,		RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
//enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ_SLOW=100, RT_HW_I2C_FREQ_FAST=400, RT_HW_I2C_FREQ_QUICK=800, RT_HW_I2C_FREQ_DEFAULT=400};
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
enum{RT_HW_UART_RX=PA12,  RT_HW_UART_TX=PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9, RT_HW_UART2_RX=PA3, RT_HW_UART2_TX=PA2, RT_HW_UART3_RX=PB11, RT_HW_UART3_TX=PB12};
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=PA13)&&((p)!=PA14)&&((p)!=PC14)&&((p)!=PC15)&&((p)!=PB2))//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ((((p)<=PB15 || ((p)==PC13)) && RT_HW_PIN_BLOCK_1)  ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((((p)<=PB15)&& RT_HW_PIN_BLOCK_1) 				? (p) : -1) 	//--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((((p)<=PA7) ||((p)==PB0)||((p)==PB1))\
															&&RT_HW_PIN_BLOCK_1)? (p) : -1) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((((p)<=PB15)||((p)==PC13))&& RT_HW_PIN_BLOCK_1)	? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((((p)<=PA10)&&((p)!=PA4)  &&((p)!=PA5))||((p)==PB0)||((p)==PB1)||((p)==PB6)||((p)==PB7)||((p)==PB8)||((p)==PB9))\
															&& RT_HW_PIN_BLOCK_1) 	? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        													//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)															//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  ((((p)<=PB15)&& RT_HW_PIN_BLOCK_1) 					? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  ((((p)<=PB15)&& RT_HW_PIN_BLOCK_1)					? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									5.2. ПЛАТФОРМА  STM32F103R
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F103R)		
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=49,	RT_HW_FCPU=16,		RT_HW_LED_BUILTIN=32, RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=64,RT_HW_SIZE_FLASH=512};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,	  RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=8}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
//#define RT_HW_UART4
//#define RT_HW_UART5
enum{RT_HW_UART_RX =PA12, RT_HW_UART_TX =PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9,  RT_HW_UART2_RX=PA3, 	RT_HW_UART2_TX=PA2,	RT_HW_UART3_RX=PB11, RT_HW_UART3_TX=PB12,
	 RT_HW_UART4_RX=PC11, RT_HW_UART4_TX=PC10, RT_HW_UART5_RX=PD2,  RT_HW_UART5_TX=PC12};	 
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=46)&&((p)!=47))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)< RT_HW_PIN_QNT_MAX) 						        ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)< RT_HW_PIN_QNT_MAX) &&  RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)< RT_HW_PIN_QNT_MAX) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||\
							    ((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1)//--Наличие пина типа PWM;
#define RT_HW_PIN_CHECK_DAC(p)  (((p)==4) || ((p)==5)  				 	? (p) : -1) //--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)< 49)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)< 49)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									5.3. ПЛАТФОРМА  STM32F103Z
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F103Z)
//------Параметры контроллера общие-------------------------------------------------------------------		
enum{RT_HW_PIN_QNT_MAX=112,	RT_HW_FCPU=74, 	  	RT_HW_LED_BUILTIN=-1,	RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=64,RT_HW_SIZE_FLASH=512};
enum{RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,	RT_HW_ADC_NULL=3,		RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=8}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
#define RT_HW_UART4
#define RT_HW_UART5
enum{RT_HW_UART_RX =PA12, RT_HW_UART_TX =PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9,  RT_HW_UART2_RX=PA3, 	RT_HW_UART2_TX=PA2,	RT_HW_UART3_RX=PB11, RT_HW_UART3_TX=PB12,
	 RT_HW_UART4_RX=PC11, RT_HW_UART4_TX=PC10, RT_HW_UART5_RX=PD2,  RT_HW_UART5_TX=PC12};
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=33)&&((p)!=34))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ( (p)< 112	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)<=112) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)<=112) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        										//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)<=112)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)<=112)&&RT_HW_PIN_BLOCK_1			? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									6.1. ПЛАТФОРМА  STM32F401 - BlackPill STM32F401
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F401xx)
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=48,	RT_HW_FCPU=84,		RT_HW_LED_BUILTIN=PC13, RT_HW_VCC=3300, RT_HW_SIZE_SRAM=64,RT_HW_SIZE_FLASH=256};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,	RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
enum{RT_HW_UART_RX=PA12,  RT_HW_UART_TX=PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9, RT_HW_UART2_RX=PA3, RT_HW_UART2_TX=PA2};
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		((((p)<RT_HW_PIN_QNT_MAX)  && ((p)!=-1) && ((p)!=27)) && (!(((p)>=32)&&((p)<=44))))//--Запрещенный набор пинов 1;	
#define RT_HW_PIN_BLOCK_2  		(((p)!=PA11)&&((p)!=PA12)&&((p)!=PC14)&&((p)!=PC15)&&((p)!=PB2))//--Запрещенный набор пинов 2;	
#define RT_HW_PIN_BLOCK_3		 RT_HW_PIN_BLOCK_1 && RT_HW_PIN_BLOCK_2							//--Запрещенный набор пинов 3;	
#define	RT_HW_PIN_CHECK_ALL(p)  (RT_HW_PIN_BLOCK_1								    ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (RT_HW_PIN_BLOCK_3 									? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((((p)>=0)&&((p)<=PA7)) ||((p)==PB0)||((p)==PB1))  ? (p) : -1) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (RT_HW_PIN_BLOCK_3	&& ((p)!=PA4) && ((p)!=PB12)	? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        													//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)															//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
//PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB12=(PB10+2),PB13,PB14,PB15,
//PC13=(32+13),PC14,PC15,
//BOARD_NR_GPIO_PINS
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									6.2. ПЛАТФОРМА  STM32F411 - BlackPill STM32F411
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F411xx)
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=48,	RT_HW_FCPU=84,		RT_HW_LED_BUILTIN=PC13, RT_HW_VCC=3300, RT_HW_SIZE_SRAM=64,RT_HW_SIZE_FLASH=256};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,	RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
enum{RT_HW_UART_RX=PA12,  RT_HW_UART_TX=PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9, RT_HW_UART2_RX=PA3, RT_HW_UART2_TX=PA2};
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		((((p)<RT_HW_PIN_QNT_MAX)  && ((p)!=-1) && ((p)!=27)) && (!(((p)>=32)&&((p)<=44))))//--Запрещенный набор пинов 1;	
#define RT_HW_PIN_BLOCK_2  		(((p)!=PA11)&&((p)!=PA12)&&((p)!=PC14)&&((p)!=PC15)&&((p)!=PB2))//--Запрещенный набор пинов 2;	
#define RT_HW_PIN_BLOCK_3		 RT_HW_PIN_BLOCK_1 && RT_HW_PIN_BLOCK_2							//--Запрещенный набор пинов 3;	
#define	RT_HW_PIN_CHECK_ALL(p)  (RT_HW_PIN_BLOCK_1								    ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (RT_HW_PIN_BLOCK_3 									? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((((p)>=0)&&((p)<=PA7)) ||((p)==PB0)||((p)==PB1))  ? (p) : -1) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (RT_HW_PIN_BLOCK_3	&& ((p)!=PA4) && ((p)!=PB12)	? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        													//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)															//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									6.3. ПЛАТФОРМА  STM32F407V
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_BOARD_STM32F407Vx)
//------Параметры контроллера общие----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=80,	RT_HW_FCPU=168,		RT_HW_LED_BUILTIN=PA6,	RT_HW_VCC=3300,		RT_HW_SIZE_SRAM=196,RT_HW_SIZE_FLASH=512};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=4,		RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=16,	RT_HW_DAC_DEPTH=8}; 
//------Контрольные пины---------------------------------------------------------------------------
enum{RT_HW_PIN_CONTROL=PE2, RT_HW_PIN_DEBUG_1=PE3,	RT_HW_PIN_DEBUG_2=PE4,	RT_HW_PIN_DEBUG_3=PE5};
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=PB7, RT_HW_I2C_SCL=PB6, RT_HW_I2C_FREQ=400};
//------Параметры SPI------------------------------------------------------------------------------	
#define RT_HW_SPI
enum{RT_HW_SPI_SS=PA4,	RT_HW_SPI_MOSI=PA7,	RT_HW_SPI_MISO=PA6,	RT_HW_SPI_SCK=PA5};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
#define RT_HW_UART1
#define RT_HW_UART2
#define RT_HW_UART3
#define RT_HW_UART4
enum{RT_HW_UART_RX=PA12,  RT_HW_UART_TX=PA11,   
	 RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9, RT_HW_UART2_RX=PA3, RT_HW_UART2_TX=PA2
	 
	 
	 };
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		((((p)<RT_HW_PIN_QNT_MAX)  && ((p)!=-1) && ((p)!=27)) && (!(((p)>=32)&&((p)<=44))))//--Запрещенный набор пинов 1;	
#define RT_HW_PIN_BLOCK_2  		(((p)!=PA11)&&((p)!=PA12)&&((p)!=PC14)&&((p)!=PC15)&&((p)!=PB2))//--Запрещенный набор пинов 2;	
#define RT_HW_PIN_BLOCK_3		 RT_HW_PIN_BLOCK_1 && RT_HW_PIN_BLOCK_2							//--Запрещенный набор пинов 3;	
#define	RT_HW_PIN_CHECK_ALL(p)  (RT_HW_PIN_BLOCK_1								    ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (RT_HW_PIN_BLOCK_3 									? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((((p)>=0)&&((p)<=PA7)) ||((p)==PB0)||((p)==PB1))  ? (p) : -1) //--Наличие пина типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (RT_HW_PIN_BLOCK_3	&& ((p)!=PA4) && ((p)!=PB12)	? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        													//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)															//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (RT_HW_PIN_BLOCK_3									? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							9.1 ПЛАТФОРМА ANON - Неопознанный контроллер
//*************************************************************************************************
#if defined(RT_HW_BOARD_ANON) 															
//------Параметры контроллера общие----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=22,	RT_HW_FCPU=16,    	RT_HW_LED_BUILTIN=-1, RT_HW_VCC=3300, 	RT_HW_SIZE_SRAM=2,	RT_HW_SIZE_FLASH=32};
enum{RT_HW_SYS_DEPTH=12,	RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4,	  RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8,	RT_HW_DAC_DEPTH=0}; 
//------Параметры i2c------------------------------------------------------------------------------	
#define RT_HW_I2C
enum{RT_HW_I2C_SDA=-1, RT_HW_I2C_SCL=-1, RT_HW_I2C_FREQ=100};
//------Параметры SPI------------------------------------------------------------------------------	
enum{RT_HW_SPI_SS=-1,	RT_HW_SPI_MOSI=-1,	RT_HW_SPI_MISO=-1,	RT_HW_SPI_SCK=-1};
//------Параметры UART-----------------------------------------------------------------------------
#define RT_HW_UART
enum{RT_HW_UART_RX=0,	RT_HW_UART_TX=1};
//------Макросы контроля номеров пинов-------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<22)               ? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=14) && ((p)<20)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (-1)								//--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Пин типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1))	//--Пин типа DIR(допускается прямое управление) 
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Номер прерывания по номеру пина
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================

