//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структуры для работы с пинами 
//				(тип RT_HW_DATE_TYPE определен выше в RT_HW_BASE_02_ARCH_DEFINED.hpp)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_PIN_DIN_ID  {RT_HW_DATE_TYPE  dir,cnt; uint16_t device:1, filter:1, normal:1, ago:1, inv:1, step:1, curBlink:1, agoBlink:1;};
struct RT_HW_PIN_ADC_ID  {RT_HW_DATE_TYPE  dir;     uint16_t device; uint16_t filter; uint16_t normal;};
struct RT_HW_PIN_TCH_ID  {RT_HW_DATE_TYPE  dir;     uint16_t device; uint16_t filter; uint16_t normal;};
struct RT_HW_PIN_HALL_ID {RT_HW_DATE_TYPE  dir;     int16_t  device;  int16_t filter;  int16_t normal;};
struct RT_HW_PIN_DOT_ID  {RT_HW_DATE_TYPE  dir;};
struct RT_HW_PIN_PWM_ID  {RT_HW_DATE_TYPE  dir,num; uint16_t device; uint16_t freq;};
struct RT_HW_PIN_DAC_ID  {RT_HW_DATE_TYPE  dir;     uint16_t device;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структуры для работы внутри класса
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----Диспетчер задач. Регистры задач-------------------------------------------------------------
struct RT_HW_STRUCT_SHAD  	{uint8_t  num,cnt,qnt;};	//--Регистры диспетчера;
//-----ДИСПЕТЧЕР ЗАДАЧ-----------------------------------------------------------------------------
struct RT_HW_STRUCT_SHED  	{RT_HW_STRUCT_SHAD quick, fast, slow, back, frdm;  uint32_t timeStart10, timeStart25;
							 uint8_t gen250; uint8_t blink; uint8_t run; uint8_t cnt50:1, cnt100:3, cnt250:4;};  
//----Структуры для системных параметров-----------------------------------------------------------						   
struct RT_HW_STRUCT_PIN   	{int8_t   control,led,but;};					//--Структура для пинов; 
struct RT_HW_STRUCT_DEPTH 	{uint8_t  sys,adc,pwm,dac,tch,vNull,drift;}; 	//--Разрешения устройств и дрейфы ADC; 
struct RT_HW_STRUCT_PWM   	{uint16_t channel; uint16_t freq;};				//--PWM; 
//----Структуры для устройств коммуникаций---------------------------------------------------------	
struct RT_HW_STRUCT_UART  	{uint16_t  begin, ready;
#if defined(RT_HW_ARCH_STM32)
uint32_t timeStart; uint16_t dir0;
#endif
};							//--UART;
struct RT_HW_STRUCT_I2C   	{int8_t   sda,scl,adr; uint8_t state; uint8_t speed; uint16_t freq;};//--i2c; 
struct RT_HW_STRUCT_SPI   	{int8_t   ss,mosi,miso,sck; char mode; uint16_t freq;};					 //--SPI; 
//----Структуры для поиска устройства на щине i2c;--------------------------------------------------
struct RT_HW_STRUCT_FIND_I2C{uint8_t custom=0;  uint8_t maxErr=20; uint8_t cntErr=0; uint8_t maxOk:4, cntOk:4; uint32_t timeDelay;}; 
//-----ТЕРМИНАЛ------------------------------------------------------------------------------------
struct RT_HW_STRUCT_CONSOLE {uint8_t dir; uint8_t cnt:4, ready:1, head:1, resetHead:1, mess:1; //uint32_t timeStart;
};	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структуры для работы с устройствами контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_DEVICE{
//-----Данные для работы с системными пинами control,led-------------------------------------------
RT_HW_STRUCT_PIN  	pin;
//-----Данные для работы с разрешениями устройств--------------------------------------------------
RT_HW_STRUCT_DEPTH	depth;
//-----Данные для работы с PWM---------------------------------------------------------------------
RT_HW_STRUCT_PWM 	pwm;
//-----Данные для работы с UART----------------------------------------------------------------
RT_HW_STRUCT_UART 	uart; 
//-----Данные для работы с i2c0--------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)			  
RT_HW_STRUCT_I2C 	i2c0;
#endif	
//-----Данные для работы с i2c1--------------------------------------------------------------------		  
#if defined(RT_HW_PERMIT_I2C1)			  
RT_HW_STRUCT_I2C 	i2c1;
#endif
//-----Данные для работы с i2c2--------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)			  
RT_HW_STRUCT_I2C 	i2c2;
#endif
//-----Данные для работы с SPI0--------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)			  
RT_HW_STRUCT_SPI 	spi0;
#endif	
//-----Данные для работы с SPI1--------------------------------------------------------------------		  
#if defined(RT_HW_PERMIT_SPI1)			  
RT_HW_STRUCT_SPI 	spi1;
#endif
//-----Данные для работы с SPI2--------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2)			  
RT_HW_STRUCT_SPI 	spi2;
#endif			  
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



