#include "RT_HW_BASE.h"
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Конструктор
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE:: RT_HW_BASE(){//console.dir=0; console.begin=console.ready=console.head=console.mess=0; 
//---Настройка диспетчера задач ------------------------------------------------------------------
shed.cnt50=shed.cnt100=shed.cnt250=shed.gen250=0;
shed.quick.cnt=shed.fast.cnt=shed.slow.cnt=shed.back.cnt=shed.frdm.cnt=0;
shed.quick.qnt=5; 							//--Кол-во срочных   задач (период  10мс);
shed.fast.qnt=4;							//--Кол-во быстрых   задач (период  25мс);
shed.slow.qnt=4; 							//--Кол-во медленных задач (период 250мс);
shed.back.qnt=5;   							//--Кол-во фоновых   задач (период 100мс);
shed.frdm.qnt=20; 							//--Кол-во свободных задач (период loop()-когда нет вызванных задач);
shed.run=0;									//--Флаги разрешения запусков задач(quick,fast,slow,back,frdm);
//---Настройка рабочих регистров-------------------------------------------------------------------
device.pin.control	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 0);	//--Пин контрольного светодиода; 
device.pin.led	 	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 1);	//--Пин светодиода на плате;
device.pin.but	 	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 2);	//--Пин кнопки на плате; 
device.depth.sys	 = getUintPGM(RT_HW_PGM_SYS_PAR_ID, 0);	//--Cистемное разрешение (8,10,12,16); 
device.depth.adc	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID, 0); //--Разрешение ADC;
device.depth.drift	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID,	1); //--Допустимый дрейф показаний ADC;
device.depth.vNull	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID, 2); //--Допустимый дрейф нуля ADC;
device.depth.tch	 = getUintPGM(RT_HW_PGM_SYS_TCH_ID, 0);	//--Разрешение TCH (ESP32);
device.depth.pwm	 = getUintPGM(RT_HW_PGM_SYS_PWM_ID, 0);	//--Разрешение PWM; 
device.depth.dac	 = getUintPGM(RT_HW_PGM_SYS_DAC_ID, 0); //--Разрешение DAC;			 
//-----Настройка разрядности ADC и PWM для контроллера SAM3X8E (Arduino DUE)-----------------------
#if defined(RT_HW_ARCH_SAM3) 
	analogReadResolution(device.depth.adc);	//--ADC; 
	analogWriteResolution(device.depth.pwm);//--PWM; 
#endif 
//-----Настройка разрядности ADC и PWM для контроллеров ST32--------------------------------------- 
#if defined(RT_HW_ARCH_STM32) 
	analogReadResolution (device.depth.adc);//--ADC; 
	analogWriteResolution(device.depth.pwm);//--PWM; 
#endif 
//---Разрешение (для STM32103С) использование выводов JTAG как GPI---------------------------------
// Synopsis: Disable JTAG PINS for JTAG (used as GPIO); SWDIO/SWDCLK - used for programming; JTDI,JTDO,JRST - used as GPIO
#if defined(RT_HW_BOARD_STM32F103Cx)	
	afio_cfg_debug_ports(AFIO_DEBUG_SW_ONLY);	
#endif
//----------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)
device.i2c0.adr	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,0);	//--адрес; 
device.i2c0.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,1);	//--SDA; 
device.i2c0.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,2);	//--SCL; 
device.i2c0.speed	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,3);	//--код частоты i2c;
device.i2c0.state=0;	
if(device.i2c0.adr>=8) {bitSet(device.i2c0.state,RT_HW_I2C_STATE_SLAVE);} //--Установка флага режима slave (если адрес <7);
#endif
#if defined(RT_HW_PERMIT_I2C1)
device.i2c1.adr	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,4);	//--адрес; 
device.i2c1.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,5);	//--SDA; 
device.i2c1.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,6);	//--SCL; 
device.i2c1.speed	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,7);	//--код частоты i2c;
device.i2c1.state=0;	
if(device.i2c1.adr>=8) {bitSet(device.i2c1.state,RT_HW_I2C_STATE_SLAVE);} //--Установка флага режима slave (если адрес <7);
#endif
#if defined(RT_HW_PERMIT_I2C2)
device.i2c2.adr	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,8);	//--адрес; 
device.i2c2.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,9);	//--SDA; 
device.i2c2.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,10);	//--SCL; 
device.i2c2.speed	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,11);	//--код частоты i2c;
device.i2c2.state=0;	
if(device.i2c2.adr>=8) {bitSet(device.i2c1.state,RT_HW_I2C_STATE_SLAVE);} //--Установка флага режима slave (если адрес <7);
#endif
//---Настройка UART---------------------------------------------------------------------------------
device.uart.begin=device.uart.ready=0; 
//-------------------------------------------------------------------------------------------------
};					
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 			Нормализация значения ADC до системного значения;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t  RT_HW_BASE::getFistBitUint16(uint16_t &reg){for(uint8_t i=0;i<=15;i++){if(!bitRead(reg,i)) return i;} return -1;};	 //--Возвращает первый свободный бит регистра reg;
uint16_t RT_HW_BASE::maxBitDepth(uint8_t  v){if(v>=16) {return 0xFFFF;} if(v==0){return 0;} return ((1<<v)-1);};			 //--Возвращает макс.число числа разрядности v;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 			Нормализация значения ADC до системного значения;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE::normADC  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.adc),0,maxBitDepth(device.depth.sys));};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 			Нормализация системного значения до значения записываемого в PWM;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE::normPWM  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.sys),0,maxBitDepth(device.depth.pwm));};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 			Нормализация истемного значения до значения записываемого в DAC;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE::normDAC  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.sys),0,maxBitDepth(device.depth.dac));};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Возвращает входное значение с поправкой на гистерезис
//  v1 - предыдущее значение;
//  v2 - новое значение
//  delta - допустимое отклонение;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: makeDelta(uint16_t v1, uint16_t v2, uint8_t delta){
if(v2>v1) {if((v2-v1)>delta) {return v2;}} 
if(v1>v2) {if((v1-v2)>delta) {return v2;}} 
return v1;}  //--Гистерезис двух величин;
//=================================================================================================
//							ФУНКЦИИ ДЛЯ РАБОТЫ С ПИНАМИ
//=================================================================================================

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//  Получение текстового обозначения типа массива (массивы с перечнем основных пинов);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
String RT_HW_BASE:: getNameKindPin(uint8_t kind){
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PAR_ID) {return String(F("par"));}	
if(kind==RT_HW_PGM_SYS_ADC_ID) {return String(F("adc"));}
if(kind==RT_HW_PGM_SYS_TCH_ID) {return String(F("tch"));}	
if(kind==RT_HW_PGM_SYS_PWM_ID) {return String(F("pwm"));}
if(kind==RT_HW_PGM_SYS_DAC_ID) {return String(F("dac"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PIN_ID) {return String(F("pin"));}
if(kind==RT_HW_PGM_PIN_I2C_ID) {return String(F("I2C"));}
if(kind==RT_HW_PGM_PIN_SPI_ID) {return String(F("SPI"));}
if(kind==RT_HW_PGM_PIN_UHS_ID) {return String(F("UHS"));}	
if(kind==RT_HW_PGM_PIN_USS_ID) {return String(F("USS"));}	
if(kind==RT_HW_PGM_PIN_CAN_ID) {return String(F("CAN"));}
if(kind==RT_HW_PGM_PIN_BTH_ID) {return String(F("BTH"));}
if(kind==RT_HW_PGM_PIN_ETH_ID) {return String(F("ETH"));}
if(kind==RT_HW_PGM_PIN_WFI_ID) {return String(F("WFI"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_ALL_ID) {return String(F("ALL"));}	
if(kind==RT_HW_PGM_PIN_DIN_ID) {return String(F("DIN"));}
if(kind==RT_HW_PGM_PIN_ADC_ID) {return String(F("ADC"));}
if(kind==RT_HW_PGM_PIN_TCH_ID) {return String(F("TCH"));}	
if(kind==RT_HW_PGM_PIN_DOT_ID) {return String(F("DOT"));}
if(kind==RT_HW_PGM_PIN_PWM_ID) {return String(F("PWM"));}
if(kind==RT_HW_PGM_PIN_DAC_ID) {return String(F("DAC"));}
if(kind==RT_HW_PGM_PIN_INT_ID) {return String(F("INT"));} 
if(kind==RT_HW_PGM_PIN_N5V_ID) {return String(F("N5V"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_DBG_ID) {return String(F("DBG"));}
if(kind==RT_HW_PGM_PIN_OUT_ID) {return String(F("OUT"));}
if(kind==RT_HW_PGM_PIN_INP_ID) {return String(F("INP"));} 
if(kind==RT_HW_PGM_PIN_DCT_ID) {return String(F("DCT"));}
if(kind==RT_HW_PGM_PIN_DEV_ID) {return String(F("DEV"));}
if(kind==RT_HW_PGM_PIN_CSS_ID) {return String(F("CSS"));}	
if(kind==RT_HW_PGM_PIN_LC6_ID) {return String(F("LC6"));}	
if(kind==RT_HW_PGM_PIN_SSP_ID) {return String(F("SSP"));}
if(kind==RT_HW_PGM_ADR_I2C_ID) {return String(F("ADR"));}
//-------------------------------------------------------------------------------------------------	
return String(F(" - "));  };
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//  	Получение значения из массива PGM;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE::readArrPGM(uint8_t kind, uint8_t n){
//-----Системные параметры-------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PAR_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_PAR,n);}
if(kind==RT_HW_PGM_SYS_ADC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_ADC,n);}
if(kind==RT_HW_PGM_SYS_TCH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_TCH,n);}
if(kind==RT_HW_PGM_SYS_PWM_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_PWM,n);}
if(kind==RT_HW_PGM_SYS_DAC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_DAC,n);}
//-----Системные пины------------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PIN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_PIN,n);}
//-----Пины интерфейсов связи----------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_I2C_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_I2C,n);}
if(kind==RT_HW_PGM_PIN_SPI_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_SPI,n);}
if(kind==RT_HW_PGM_PIN_UHS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_UHS,n);}
if(kind==RT_HW_PGM_PIN_USS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_USS,n);}
if(kind==RT_HW_PGM_PIN_CAN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_CAN,n);}
if(kind==RT_HW_PGM_PIN_BTH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_BTH,n);}
if(kind==RT_HW_PGM_PIN_ETH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ETH,n);}
if(kind==RT_HW_PGM_PIN_WFI_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_WFI,n);}
//-----Пины контроллера----------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_ALL_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ALL,n);}
if(kind==RT_HW_PGM_PIN_DIN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DIN,n);}
if(kind==RT_HW_PGM_PIN_ADC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ADC,n);}
if(kind==RT_HW_PGM_PIN_TCH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_TCH,n);}
if(kind==RT_HW_PGM_PIN_DOT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DOT,n);}
if(kind==RT_HW_PGM_PIN_PWM_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_PWM,n);}
if(kind==RT_HW_PGM_PIN_DAC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DAC,n);}
if(kind==RT_HW_PGM_PIN_INT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_INT,n);}
if(kind==RT_HW_PGM_PIN_N5V_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_N5V,n);}
//-----Тестовые пины-------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_DBG_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DBG,n);}
if(kind==RT_HW_PGM_PIN_OUT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_OUT,n);}
if(kind==RT_HW_PGM_PIN_INP_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_INP,n);}
if(kind==RT_HW_PGM_PIN_DCT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DCT,n);}
if(kind==RT_HW_PGM_PIN_DEV_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DEV,n);}
if(kind==RT_HW_PGM_PIN_CSS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_CSS,n);}
if(kind==RT_HW_PGM_PIN_LC6_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_LC6,n);}
if(kind==RT_HW_PGM_PIN_SSP_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_SSP,n);}
//-----Тестовые адреса устройств i2c---------------------------------------------------------------
if(kind==RT_HW_PGM_ADR_I2C_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_ADR_I2C,n);}
//-------------------------------------------------------------------------------------------------
return 0;	
//-------------------------------------------------------------------------------------------------
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Возвращает размер массива PGM
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getLenFullPGM(uint8_t kind){int8_t k; uint8_t cnt=0;
for(uint8_t i=0;i<=127;i++){k=(int8_t)readArrPGM(kind,i); if(k==RT_HW_PGM_END){break;}           cnt++;} return cnt;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Возвращает размер массива только из значений в диапазоне 0-127;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getLenPosPGM(uint8_t kind){int8_t k; uint8_t cnt=0;
for(uint8_t i=0;i<=127;i++){k=(int8_t)readArrPGM(kind,i); if(k==RT_HW_PGM_END){break;} if(k>=0) {cnt++;}} return cnt;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Проверяет наличие пина в массиве PGM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_BASE:: checkPinPGM(uint8_t kind, uint8_t n){int8_t k=0;
for(uint8_t i=0;i<=127;i++){k=readArrPGM(kind,i); if(k==RT_HW_PGM_END){return  0;} if(k==n){return 1;}} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Возвращает значение uint8_t  из массива PGM по индексу. Если n>длины массива,то возвращается 0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int8_t RT_HW_BASE:: getIntPGM	 (uint8_t kind, uint8_t n){uint8_t len;
len=getLenFullPGM(kind); if(n>=len) {return -1;}  return (int8_t)readArrPGM(kind,n);} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Возвращает значение int8_t  из массива PGM по индексу. Если n>длины массива,то возвращается -1;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getUintPGM   (uint8_t kind, uint8_t n){uint8_t len;
len=getLenFullPGM(kind); if(n>=len) {return -0;} return (uint8_t)readArrPGM(kind,n);};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   Возвращает значение uint16_t  из массива PGM по индексу. Если n>длины массива,то возвращается 0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint16_t RT_HW_BASE:: getValPGM	 (uint8_t kind, uint8_t n){uint8_t len;
len=getLenFullPGM(kind); if((n+1)>=len) {return 0;} return (((uint8_t)readArrPGM(kind,n)<<8) + ((uint8_t)readArrPGM(kind,n+1)));} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//  Получение номера пина из массива и размер массива.
//  	Признак окончания массива RT_HW_PIN_PGM_END(=-2). 
//       Если в массиве встретится такое значение (=-2, 254, 0xfe), то последующие данные будут проигнорированы!!! 
//  	mode='A' ->  вывод всех элементов в формате int8_t 	с форматированием;
//		mode='B' ->  вывод всех элементов в формате uint8_t c форматированием;
//		mode='U' ->  вывод всех элементов в формате uint8_t c форматированием до трех знаков (вывод байтов);
//		mode='C' ->  вывод элементов 0-127, вместо остальных элементов выводятся заполнители;
//      mode='D' ->  вывод элементов 0-127, остальные элементы не выводятся;
//  	mode='S' ->  вывод всех элементов в формате int8_t без форматирования;
//      mode='P' ->  вывод в формате пинов(для ESP8266,STM32 в текстовой форме),вместо отсутствующих пины(=-1) выводится заполнитель;
//      mode='N' ->  ничего не выводится;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: printArrPGM  (uint8_t kind, char mode){int8_t k; uint8_t len,sz; uint8_t cnt=0; uint8_t delim=0;
if(kind>RT_HW_PGM_QNT_ID) 	{return;}	//--Выход по несущкствующему типу массива; 
//----Проверка допустимости символа kind-----------------------------------------------------------
char  bf[7]={'A','B','C','D','S','P','U'};
len=0; for(uint8_t i=0; i<7;i++){if(mode==bf[i]){len++;}} if(len==0) {return;}
//----Вычисление длины массива---------------------------------------------------------------------
len=getLenFullPGM(kind); 									//--Получение общей длины массива;
sz =getLenPosPGM(kind); 									//--Получение кол-ва положительных (>=0) значений в массиве;
if(len==0) 					{return;}						//--Выход, если нет массив пуст;
if(((mode=='D') || (mode=='P'))  && (sz==0)){return;}		//--Выход по свойствам режим 'D';
String str=getNameKindPin(kind); printStr(str); 			//--Вывод обозначения массива;
if(( mode=='D') || (mode=='P')) {k=sz;} else {k=len;}		//--Установка кол-ва рассматриваемых элементов в массиве;
printChar('['); printVal('D',0,']',k); printChar(':',' ');	//--Вывод размера массива;
for(uint8_t i=0;i<len;i++){									//--Цикл
	if(delim==1) {printChar(',');} 
	if(delim==2) {printChar(' ');}							//--Вывод разделителя;
	k=(int8_t)readArrPGM(kind,i); 							//--Получения элемента по индексу i;	
	if(mode=='A') {           printVal('I',RT_HW_PIN_TXT_LEN,'~',         k);  delim=1; cnt++;}
	if(mode=='B') {           printVal('U',RT_HW_PIN_TXT_LEN,'~',(uint8_t)k);  delim=1; cnt++;}
	if(mode=='U') {           printVal('U',				   3,'~',(uint8_t)k);  delim=1; cnt++;}
	if(mode=='C') {if(k>=0)  {printVal('I',RT_HW_PIN_TXT_LEN,'~',         k);} else {printBlank((RT_HW_PIN_TXT_LEN-1),' ','*');} delim=1; cnt++;}
	if(mode=='D') {if(k>=0)  {printVal('I',RT_HW_PIN_TXT_LEN,'~',         k);  delim=1; cnt++;} else {delim=0;}}
	if(mode=='S') {           printVal('S',				   0,'~',         k);  delim=1; cnt++;}
	if(mode=='P') {printPin(k); if(k>=0) {delim=1;} else {delim=2;} cnt++;}
	//if(k>=0)  {printVal('I',RT_HW_PIN_TXT_LEN,'~',         k);} else {printBlank(RT_HW_PIN_TXT_LEN,'-');} delim=1; cnt++;
	//-------------------------------------------
	if(mode=='D') {if((cnt>=RT_HW_PIN_QNT_LINE) || ((i+1)>=sz))  {cnt=delim=0; printChar(';'); printCR(); if((i+1)<sz) {printBlank(9);}}}
	else		  {if((cnt>=RT_HW_PIN_QNT_LINE) || ((i+1)>=len)) {cnt=delim=0; printChar(';'); printCR(); if((i+1)<len){printBlank(9);}}}
}}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	var_ID: Возвращает цифру  из выводимой переменной начиная со старшей позиции
//  val - значение числа; len - число значащих цифр; mode -формат D,H,B; 
//  n   - номер позиции с младшей цифры 1,2...10;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getNumberVal(uint32_t val, char mode, uint8_t len, uint8_t n){uint32_t buff32=0;
if((n>len) || (n>10)) n=0; 
if(mode=='B') {buff32=(val>>(len-n))&1;}
if(mode=='H') {buff32=(val>>(len-n)*4)&0xf;}
if(mode=='D') {n=len-n+1; while(n!=0) {buff32=val; val/=10; buff32=buff32-(val*10); n--;};}
//if(buff32<=9) {buff32=buff32 +'0';} else {buff32=buff32-10+(upper ? 'A' : 'a') ;}
return (uint8_t)buff32;}; 
//---------------------------------------------------------------------------------------		
RT_HW_BASE RT_HW_Base;//--Создание внешнего объекта	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++