#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Возврат прошедшего времени: timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_BASE:: getPastTime(uint32_t &timeBegin, uint32_t timeEnd)   {if(timeEnd >= timeBegin) return (timeEnd-timeBegin); else return (0xFFFFFFFF-timeBegin+timeEnd);}; 
uint32_t RT_HW_BASE:: getPastMs	 (uint32_t &timeBegin){buff32=RT_HW_MILLIS; if(buff32  >= timeBegin) return (buff32 -timeBegin); else return (0xFFFFFFFF-timeBegin+buff32); };	
uint32_t RT_HW_BASE:: getPastMcs (uint32_t &timeBegin){buff32=RT_HW_MICROS; if(buff32  >= timeBegin) return (buff32 -timeBegin); else return (0xFFFFFFFF-timeBegin+buff32); };			
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Возврат 1 по тайм-ауту:     timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  RT_HW_BASE:: timeOut    (uint32_t &timeBegin, uint32_t timeEnd,   uint16_t timeMax){if(timeEnd>=timeBegin)  {if((timeEnd-timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-timeEnd)> timeMax) return 1; else return 0;}}; 
uint8_t  RT_HW_BASE:: timeOutMs  (uint32_t &timeBegin, uint16_t timeMax){buff32=RT_HW_MILLIS;if(buff32 >= timeBegin) {if((buff32 -timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-buff32) > timeMax) return 1; else return 0;}}; 
uint8_t  RT_HW_BASE:: timeOutMcs (uint32_t &timeBegin, uint16_t timeMax){buff32=RT_HW_MICROS;if(buff32 >= timeBegin) {if((buff32 -timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-buff32) > timeMax) return 1; else return 0;}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Функция генерит событие с точным поддержанием периода и защитой от пропуска шага. Идея от https://alexgyver.ru/arduino-algorithms/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t RT_HW_BASE:: period      (uint32_t &timeBegin, uint32_t timeEnd, uint32_t period){if((timeEnd-timeBegin)>=period) {do{timeBegin += period; if (timeBegin < period) break;} while (timeBegin < timeEnd - period); return 1;} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//										Диспетчер задач
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void 	RT_HW_BASE:: sheduler(){ 
shed.quick.num=shed.fast.num=shed.slow.num=shed.back.num=shed.frdm.num=0;
												shed.blink=shed.blink^1; 										//--бит 0 - loop()
if(period(shed.timeStart10,RT_HW_MICROS,10000)){shed.blink=shed.blink^0x02; bitSet(shed.run,0);}				//--бит 1 -  10мс
if(period(shed.timeStart25,RT_HW_MILLIS,25))   {shed.blink=shed.blink^0x04; bitSet(shed.run,1);					//--бит 2 -  25мс
 if(++shed.cnt250 >=10){shed.cnt250=0;          shed.blink=shed.blink^0x20; bitSet(shed.run,2); shed.gen250++;}	//--бит 5 - 250мс	
 if(++shed.cnt100 >= 4){shed.cnt100=0;	 		shed.blink=shed.blink^0x10; bitSet(shed.run,3);} 				//--бит 4 - 100мс
 if(shed.cnt50++  >= 1){shed.cnt50 =0;			shed.blink=shed.blink^0x08;} } 									//--бит 3 -  50мс			
//---Обработка вызова задач
if(shed.run){
 if(bitRead(shed.run,0)) {if(++shed.quick.cnt>shed.quick.qnt){shed.quick.cnt=1;} shed.quick.num=shed.quick.cnt; bitClear(shed.run,0); return;}
 if(bitRead(shed.run,1)) {if(++shed.fast.cnt >shed.fast.qnt) {shed.fast.cnt =1;} shed.fast.num =shed.fast.cnt;  bitClear(shed.run,1); return;}
 if(bitRead(shed.run,2)) {if(++shed.slow.cnt >shed.slow.qnt) {shed.slow.cnt =1;} shed.slow.num =shed.slow.cnt;  bitClear(shed.run,2); return;}
 if(bitRead(shed.run,3)) {if(++shed.back.cnt >shed.back.qnt) {shed.back.cnt =1;} shed.back.num =shed.back.cnt;  bitClear(shed.run,3); return;}}
				    else {if(++shed.frdm.cnt >shed.frdm.qnt) {shed.frdm.cnt =1;} shed.frdm.num =shed.frdm.cnt;                        return;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
