#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.1.Вывод наименования архитектуры и контроллера, номера библиотеки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printNameBoard(){ if(printCheck()){String str;
#if defined(RT_HW_BOARD_AVR328)
printTxt(String(F("arch:")));	printTxt(RT_HW_ARCH_NAME,';');  		printBlank(2);
printTxt(String(F("board:")));	printTxt(RT_HW_BOARD_NAME,';'); 		printBlank(2);
printTxt(String(F("Fcpu=")));	printVal('S',0,';',RT_HW_FCPU); 	printBlank(2);
printTxt(String(F("Vcc=")));	printFloat((float)RT_HW_VCC/1000,'1',';');	printBlank(2);
printTxt(String(F("Lib:")));	printTxt(RT_HW_BASE_VER_NAME,';'); printCR();
#else
str=__DATE__; printStr(str,';'); printBlank(59);
str=__TIME__; printStr(str,';'); printCR();
printTxt(String(F("Архитектура:")));printTxt(RT_HW_ARCH_NAME,';'); 		printBlank(2);
printTxt(String(F("Плата:")));		printTxt(RT_HW_BOARD_NAME,';');		printBlank(2);
printTxt(String(F("Версия библиотеки:"))); printTxt(RT_HW_BASE_VER_NAME,';');	
#if defined(RT_HW_ARCH_STM32)
printTxt(String(F(" ***ARCH STM32*** ")));
#endif
#if defined(RT_HW_ARCH_ESP)
printTxt(String(F(" ***ARCH ESP *** ")));
#endif
printCR();
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.2.Вывод параметров контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamBoard(){if(printCheck()){
#if defined(RT_HW_BOARD_AVR328)
printTxt(String(F("control=")));printPin(device.pin.control,';');			printBlank(2);
printTxt(String(F("led=")));	printPin(device.pin.led,';');				printBlank(2);
printTxt(String(F("ROM="))); 	printVal('S',0,';',RT_HW_MEM_ROM); 			printBlank(2);
printTxt(String(F("RAM=")));	printVal('S',0,';',RT_HW_MEM_RAM);			printBlank(2);
printTxt(String(F("EEPROM=")));	printVal('S',0,';',RT_HW_MEM_EEPROM); 		printCR();
#else
uint8_t ok=0;	
if(device.pin.control>=0){printTxt(String(F("Контрольный пин="))); printPin(device.pin.control,';'); ok=1; printBlank(2);}
if(device.pin.led>=0)	 {printTxt(String(F("Пин светодиода=")));  printPin(device.pin.led,';'); 	 ok=1; printBlank(2);} 	  
if(device.pin.but>=0)	 {printTxt(String(F("Пин кнопки=")));	   printPin(device.pin.but,';'); 	 ok=1; printBlank(2);}  
if(ok) {printCR();}
printTxt(String(F("Объем памяти->"))); 
						  printTxt(String(F("ROM="))); 		printVal('S',0,';',RT_HW_MEM_ROM); 		printBlank(2);
						  printTxt(String(F("RAM=")));		printVal('S',0,';',RT_HW_MEM_RAM);		printBlank(2);
if(RT_HW_MEM_EEPROM>0)	 {printTxt(String(F("EEPROM=")));	printVal('S',0,';',RT_HW_MEM_EEPROM); 	printBlank(2);}
if(RT_HW_MEM_RTC>0) 	 {printTxt(String(F("RTC=")));		printVal('S',0,';',RT_HW_MEM_RTC); 		printBlank(2);}
if(RT_HW_MEM_EXT_RAM>0)  {printTxt(String(F("EXT_RAM=")));	printVal('S',0,';',RT_HW_MEM_EXT_RAM); 	printBlank(2);}
printCR();
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.2.Вывод разрядности контроллера и его устройств
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printDepthBoard(){if(printCheck()){ 
#if defined(RT_HW_BOARD_AVR328)
printTxt(String(F("depth->SYS,ADC,PWM:")));
print_v8('S',0,'~',3,device.depth.sys, device.depth.adc, device.depth.pwm); 							printBlank(2);
printTxt(String(F("SYS.max=")));         printVal('S',0,';',maxBitDepth(device.depth.sys)); 			printBlank(2);
printTxt(String(F("ADC->drift,null:"))); print_v8('S',0,'~',2,device.depth.drift, device.depth.vNull);	printCR();
#elif defined(ESP32)
printTxt(String(F("Разрядность->SYS,ADC,PWM,DAC,TCH:")));
print_v8('S',0,'C',4,  device.depth.sys,device.depth.adc,device.depth.pwm, device.depth.dac);
printVal('S',0,';',device.depth.tch); 																	printBlank(2);
printTxt(String(F("SYS.max=")));         printVal('S',0,';',maxBitDepth(device.depth.sys)); 			printBlank(2);
printTxt(String(F("Дрейф ADC->показания,ноль:"))); print_v8('S',0,'~',2,device.depth.drift, device.depth.vNull);printCR();
#else
uint8_t qnt; 
if(device.depth.dac>0){qnt=4;printTxt(String(F("Разрядность->SYS,ADC,PWM,DAC:")));}  else{qnt=4;printTxt(String(F("Разрядность->SYS,ADC,PWM:")));}
print_v8('S',0,'~',qnt,device.depth.sys,device.depth.adc,device.depth.pwm,device.depth.dac); 			printBlank(2);
printTxt(String(F("SYS.max=")));         printVal('S',0,';',maxBitDepth(device.depth.sys));				printBlank(2); 				  
printTxt(String(F("Дрейф ADC->показания,ноль:"))); print_v8('S',0,'~',2,device.depth.drift, device.depth.vNull);printCR();
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.3.Вывод параметров i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void RT_HW_BASE::printParamWire(){if(printCheck()){ 							
#if defined(RT_HW_PERMIT_I2C0)
printTxt(String(F("i2c."))); 
if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_SLAVE)) {printTxt(String(F("slave="))); printVal('D',0,':',device.i2c0.adr);} 
												else {printTxt(String(F("master:")));} 
printTxt(String(F(" SDA=")));	
printPin(device.i2c0.sda,',');
printTxt(String(F(" SCL=")));	
printPin(device.i2c0.scl,',');
printTxt(String(F(" Freq="))); printVal('S',0,'~',convertModeFreqWire(device.i2c0.speed)/1000); printTxt(String(F("kHz;")),'Y');
#endif 
#if defined(RT_HW_PERMIT_I2C1)
printTxt(String(F("i2c1."))); 
if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_SLAVE)) {printTxt(String(F("slave="))); printVal('D',0,':',device.i2c1.adr);} 
												else {printTxt(String(F("master:")));} 
printTxt(String(F(" SDA1=")));	printPin(device.i2c1.sda,',');
printTxt(String(F(" SCL1=")));	printPin(device.i2c1.scl,',');
printTxt(String(F(" Freq1=")));	printVal('S',0,'~',convertModeFreqWire(device.i2c1.speed)/1000); printTxt(String(F("kHz;")),'Y');
#endif 
#if defined(RT_HW_PERMIT_I2C2)
printTxt(String(F("i2c2."))); 
if(bitRead(device.i2c2.state,RT_HW_I2C_STATE_SLAVE)) {printTxt(String(F("slave="))); printVal('D',0,':',device.i2c2.adr);} 
												else {printTxt(String(F("master:")));} 
printTxt(String(F(" SDA2=")));	printPin(device.i2c2.sda,',');
printTxt(String(F(" SCL2=")));	printPin(device.i2c2.scl,',');
printTxt(String(F(" Freq2=")));	printVal('S',0,'~',convertModeFreqWire(device.i2c2.speed)/1000); printTxt(String(F("kHz;")),'Y');
#endif  
#if defined(RT_HW_ARCH_ESP8266) && defined(RT_HW_PERMIT_I2C0)
printTxt(String(F("*** i2c.ESP8266->Под SDA,SCL разрешено использовать пины D1-D8,RX,TX;")),'Y');
#endif
#if defined(RT_HW_ARCH_ESP32)   && defined(RT_HW_PERMIT_I2C0)
printTxt(String(F("*** i2c.ESP32->Под SDA,SCL разрешено использовать пины с номерами <=34;")),'Y'); printBlank(15);
printTxt(String(F("Текущая версия ядра v.1.0.4 не поддерживает режим slave.")),'Y');
#endif
#if defined(RT_HW_ARCH_STM32) && defined(RT_HW_PERMIT_I2C0)
printTxt(String(F("*** i2c.STM32->Основные пины:SDA=PB7, SCL=PB6;")),'Y');  printBlank(15);
printTxt(String(F("Альтернативные пины:SDA=PB9, SCL=PB9;")),'Y');
#endif
#if defined(RT_HW_ARCH_STM32) && defined(RT_HW_PERMIT_I2C1)
printTxt(String(F("*** i2c1.STM32->SDA=PB11, SCL=PB10; ***")),'Y');
#endif
#if defined(RT_HW_ARCH_STM32) && defined(RT_HW_PERMIT_I2C2)
printTxt(String(F("*** i2c2.STM32->SDA=PBH8, SCL=PH11; ***")),'Y');
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.4.Вывод параметров SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamSPI(){ if(printCheck()){
#ifdef RT_HW_PERMIT_SPI0
printTxt(String(F("SPI-->SS,MOSI,MISO,SCK:"))); 
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 0),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 1),',');
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 2),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 3),';'); 
printCR();
#endif 
#ifdef RT_HW_PERMIT_SPI1
printTxt(String(F("SPI1->SS,MOSI,MISO,SCK:"))); 
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 4),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 5),',');
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 6),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 7),';'); 
printCR();
#endif
 #ifdef RT_HW_PERMIT_SPI2
printTxt(String(F("SPI2->SS,MOSI,MISO,SCK:"))); 
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 8),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 9),',');
printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID,10),','); printPin(getIntPGM(RT_HW_PGM_PIN_SPI_ID,11),';'); 
printCR();
#endif 
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.5.Вывод параметров UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamUART(){ if(printCheck()){printNumUART();}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			1.6. Создание объекта для программного UART 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
#define RT_HW_PRINT_NUM_UART 6
void  RT_HW_BASE:: printNumUART(){if(printCheck()){//uint8_t qnt=6;
printTxt(String(F("UART(RX,TX)->")));
uint8_t cnt=0;
#ifdef RT_HW_PERMIT_UART0
cnt++;	printTxt(String(F(" UART:")));  	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,0),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,1),';');   
#endif
#ifdef RT_HW_PERMIT_UART1
cnt++;	printTxt(String(F(" UART1:"))); 	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,2),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,3),';'); 
#endif
#ifdef RT_HW_PERMIT_UART2
cnt++;	printTxt(String(F(" UART2:"))); 	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,4),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,5),';');  
#endif
#ifdef RT_HW_PERMIT_UART3
cnt++;  printTxt(String(F(" UART3:"))); 	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,6),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,7),';'); 	
#endif
#ifdef RT_HW_PERMIT_UART4
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;printCR(); printBlank(13);}; 
		printTxt(String(F(" UART4:")));	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,8),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,9),';');  
#endif
#ifdef RT_HW_PERMIT_UART5
if(++cnt>=RT_HW_PRINT_NUM_UART){cnt=0; printCR(); printBlank(13);}; 
		printTxt(String(F(" UART5:")));	printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,10),',');printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,11),';'); 
#endif
#ifdef RT_HW_PERMIT_UART6
if(++cnt>=RT_HW_PRINT_NUM_UART){cnt=0; printCR(); printBlank(13);}; 
		printTxt(String(F(" UART6:")));printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,12),','); printPin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,13),';'); ;
#endif
#ifdef RT_HW_PERMIT_UARTS
if(++cnt>=RT_HW_PRINT_NUM_UART){cnt=0; printCR(); printBlank(13);}; 
		printTxt(String(F(" UARTS:")));	printPin(getIntPGM(RT_HW_PGM_PIN_USS_ID,0),','); printPin(getIntPGM(RT_HW_PGM_PIN_USS_ID,1),';'); 
#endif
printCR();	
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6.Вывод параметров CAN
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamCAN(){
#ifdef RT_HW_PERMIT_CAN
if(printCheck()){printTxt(String(F("CAN->RX,TX: "))); 
printPin(getIntPGM(RT_HW_PGM_PIN_CAN_ID,0),','); 
printPin(getIntPGM(RT_HW_PGM_PIN_CAN_ID,1),';'); 
printCR();}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6.Вывод параметров BlueTooth
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamBTH(){
#ifdef RT_HW_PERMIT_BTH
if(printCheck()){printTxt(String(F("BlueTooth->в разработке:"))); 
printChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,0));
printChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,1));
printChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,2));
printChar(';','Y');}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6.Вывод параметров Ethernet
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamETH(){
#ifdef RT_HW_PERMIT_ETH
if(printCheck()){printTxt(String(F("Ethernet->в разработке:"))); 
printInt8(getUintPGM(RT_HW_PGM_PIN_ETH_ID,0),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_ETH_ID,1),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_ETH_ID,2),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_ETH_ID,3),'U',';');
printCR();}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6.Вывод параметров Wi-Fi
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printParamWFI(){
#ifdef RT_HW_PERMIT_WFI
if(printCheck()){printTxt(String(F("WiFi->в разработке:"))); 
printInt8(getUintPGM(RT_HW_PGM_PIN_WFI_ID,0),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_WFI_ID,1),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_WFI_ID,2),'U','.');
printInt8(getUintPGM(RT_HW_PGM_PIN_WFI_ID,3),'U',';');
printCR();}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2. Вывод доступных пинов контроллера 
//  	mode='A' ->  вывод всех элементов в формате int8_t 	с форматированием;
//		mode='B' ->  вывод всех элементов в формате uint8_t c форматированием;
//		mode='U' ->  вывод всех элементов в формате uint8_t c форматированием до трех знаков (вывод байтов);
//		mode='C' ->  вывод элементов 0-127, вместо остальных элементов выводятся заполнители;
//      mode='D' ->  вывод элементов 0-127, остальные элементы не выводятся;
//  	mode='S' ->  вывод всех элементов в формате int8_t без форматирования;
//      mode='P' ->  вывод в формате пинов(для ESP8266,STM32 в текстовой форме),вместо отсутствующих пины(=-1) выводится заполнитель;
//      mode='N' ->  ничего не выводится;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----Системные параметры-------------------------------------------------------------------------
void RT_HW_BASE::printSysParam	(char mode){if(printCheck()){for(uint8_t i=0;i<=RT_HW_PGM_SYS_DAC_ID;i++){printArrPGM(i,mode);}}};
//-----Системные пины------------------------------------------------------------------------------
void RT_HW_BASE::printSysPins	(char mode){if(printCheck()){printArrPGM(RT_HW_PGM_SYS_PIN_ID,mode);}};		
//-----Интерфейсные пины---------------------------------------------------------------------------
void RT_HW_BASE::printLinkPins	(char mode){if(printCheck()){for(uint8_t i=RT_HW_PGM_PIN_I2C_ID;i<=RT_HW_PGM_PIN_BTH_ID;i++){printArrPGM(i,mode);}}};
//-----Сетевые параметры---------------------------------------------------------------------------
void RT_HW_BASE::printNetParam	(char mode){if(printCheck()){for(uint8_t i=RT_HW_PGM_PIN_ETH_ID;i<=RT_HW_PGM_PIN_WFI_ID;i++){printArrPGM(i,mode);}}};
//-----Пины контроллера----------------------------------------------------------------------------
void RT_HW_BASE::printPinsBoard(char mode){if(printCheck()){for(uint8_t i=RT_HW_PGM_PIN_ALL_ID;i<=RT_HW_PGM_PIN_N5V_ID;i++){printArrPGM(i,mode);}}};	
//-----Тестовые пины------------------------------------------------------------------------------- 
void RT_HW_BASE::printPinsTest	(char mode){if(printCheck()){for(uint8_t i=RT_HW_PGM_PIN_DBG_ID;i<=RT_HW_PGM_PIN_SSP_ID;i++){printArrPGM(i,mode);}}};	
//-----Адреса устройства(i2c  и др.)--------------------------------------------------------------- 
void RT_HW_BASE::printAdrTest	(char mode){if(printCheck()){printArrPGM(RT_HW_PGM_ADR_I2C_ID,mode);}};	
//-----На проверка на наличие до 4-х пинов---------------------------------------------------------
bool RT_HW_BASE:: checkPinx4(uint8_t qnt, int8_t v1,int8_t v2, int8_t v3, int8_t v4){
if(((qnt>=1)&&((int8_t)v1>=0))||((qnt>=2)&&((int8_t)v2>=0)) ||((qnt>=3)&&((int8_t)v3>=0))||((qnt>=1)&&((int8_t)v1>=0))){return 1;} else {return 0;}}
//-----Вывод до 4-х пинов--------------------------------------------------------------------------
void RT_HW_BASE:: printPinx4(uint8_t qnt, int8_t v1,int8_t v2, int8_t v3, int8_t v4){if(printCheck()){
if(qnt>=1) {							RT_HW_Base.printPin(v1);} 
if(qnt>=2) {RT_HW_Base.printChar(',');	RT_HW_Base.printPin(v2);} 
if(qnt>=3) {RT_HW_Base.printChar(',');	RT_HW_Base.printPin(v3);} 
if(qnt>=4) {RT_HW_Base.printChar(',');	RT_HW_Base.printPin(v4);} 
printChar(';','Y');
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Вывод на консоль отформатированный вывод пина с суффиксом по его номеру
//		для ESP8266 - в формате D0-D8,RX,TX,A0;
//		для STM32	- в формату Pxx (PA0,PA15,PB0,PB15 и т.д.)
//	Если номер pin не допустим для контроллера, выводится символ '*'.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printPin(int8_t pin, char suff){
#if defined(RT_HW_ARCH_ESP8266)	
if(pin==pD0) {printTextStr("D0",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD1) {printTextStr("D1",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD2) {printTextStr("D2",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD3) {printTextStr("D3",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD4) {printTextStr("D4",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD5) {printTextStr("D5",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD6) {printTextStr("D6",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD7) {printTextStr("D7",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pD8) {printTextStr("D8",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pRX) {printTextStr("RX",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pTX) {printTextStr("TX",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==pA0) {printTextStr("A0",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
			 {printTextStr ("-",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;} 
#elif defined(RT_HW_ARCH_STM32)			 
printTextStr(getNamePinSTM32(pin),RT_HW_PIN_TXT_LEN,'L',' ',suff); return;
#else
if(pin>=0)  {printVal('I',RT_HW_PIN_TXT_LEN,suff,pin);} else {printBlank((RT_HW_PIN_TXT_LEN-1),' ','*'); printSuff(suff);}; return;	
#endif		
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3. Вывод наименование пинов (ESP8266,STM32) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printNamePins(){						
#if defined(RT_HW_ARCH_ESP8266)
printTextStr(String(F("Значения GPIO контроллеров ESP8226")), 80, 'C', '-', 'Y');
printTxt(String(F("D0=16, D1=5, D2=4, D3=0, D4=2, D5=14, D6=12, D7=13, D8=15, RX=3, TX=1, A0=17;")),'Y');
#endif
#if defined(RT_HW_ARCH_STM32)
printTextStr(String(F("Наименование пинов STM32")), 80, 'C', '-', 'Y');
printTablePinsSTM32();
#endif
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++