#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.0. Создание объекта для программного UART 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
#if defined(RT_HW_PERMIT_UARTS)
SoftwareSerial SerialS(RT_HW_UARTS_RX, RT_HW_UARTS_TX);
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.2. Функция uartBegin(n,speed)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void  RT_HW_BASE:: uartBegin (uint8_t n, uint32_t speed){
#if defined(RT_HW_PERMIT_UART0)
if(n==0){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial.begin(speed);}}
#endif	
#if	defined(RT_HW_PERMIT_UART1)
if(n==1){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial1.begin(speed);}}
#endif		
#if	defined(RT_HW_PERMIT_UART2)
if(n==2){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial2.begin(speed);}}
#endif	
#if	defined(RT_HW_PERMIT_UART3)
if(n==3){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial3.begin(speed);}}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial4.begin(speed);}}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial5.begin(speed);}}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); Serial6.begin(speed);}}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){if(!bitRead(device.uart.begin,n)) {bitSet(device.uart.begin,n); SerialS.begin(speed);}}
#endif			
}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.3. uartSerial(n) проверка подключения устройства.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t  RT_HW_BASE:: uartSerial (uint8_t n){
//--Проверка с учетом особенностей STM32 в среде STM32duino
#ifdef RT_HW_PERMIT_UART0
if(n==0){
//--------Для 
#if defined(RT_HW_ARCH_STM32)	
#if defined (USBCON) && defined(USBD_USE_CDC)
if(device.uart.dir0==4) {return 1;}
if(device.uart.dir0==0) {device.uart.timeStart=RT_HW_MILLIS; device.uart.dir0++; return 0;}
if(device.uart.dir0==1) {if(RT_HW_MILLIS>=(device.uart.timeStart+10)) {
						 device.uart.timeStart=RT_HW_MILLIS; if(CDC_connected()) {device.uart.dir0++;}; return 0;}}
if(device.uart.dir0==2) {if(RT_HW_MILLIS>=(device.uart.timeStart+20)){bitSet(device.uart.ready,0); device.uart.dir0=4; return 1;}						 
}	
#endif	 //--END if defined (USBCON) && defined(USBD_USE_CDC)
#else	
if(Serial) {bitSet(device.uart.ready,n);}
#endif
return 0;}
#endif
//---UART1 (STM32 UART2---------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_UART1
if(n==1){if(Serial1){bitSet(device.uart.ready,n);}}
#endif		
#ifdef RT_HW_PERMIT_UART2
if(n==2){if(Serial2){bitSet(device.uart.ready,n);}}
#endif	
#ifdef RT_HW_PERMIT_UART3
if(n==3){if(Serial3){bitSet(device.uart.ready,n);}}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){if(Serial4){bitSet(device.uart.ready,n);}}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){if(Serial5){bitSet(device.uart.ready,n);}}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){if(Serial6){bitSet(device.uart.ready,n);}}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){if(SerialS){bitSet(device.uart.ready,n);}}
#endif	
return 	(uint8_t)bitRead(device.uart.ready,n);	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.4. uartAvaible(n)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t  RT_HW_BASE:: uartAvailable(uint8_t n){uint8_t qnt=0;
#ifdef RT_HW_PERMIT_UART0
if(n==0){qnt=Serial.available();}
#endif	
#ifdef RT_HW_PERMIT_UART1
if(n==1){qnt=Serial1.available();}
#endif		
#ifdef RT_HW_PERMIT_UART2
if(n==2){qnt=Serial2.available();}
#endif	
#ifdef RT_HW_PERMIT_UART3
if(n==3){qnt=Serial3.available();}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){qnt=Serial4.available();}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){qnt=Serial5.available();}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){qnt=Serial6.available();}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){qnt=SerialS.available();}
#endif	
return 	qnt;	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.5. uartRead(n)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t RT_HW_BASE:: uartRead(uint8_t n){uint8_t val=0;
#ifdef RT_HW_PERMIT_UART0
if(n==0){val=Serial.read();}
#endif	
#ifdef RT_HW_PERMIT_UART1
if(n==1){val=Serial1.read();}
#endif		
#ifdef RT_HW_PERMIT_UART2
if(n==2){val=Serial2.read();}
#endif	
#ifdef RT_HW_PERMIT_UART3
if(n==3){val=Serial3.read();}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){val=Serial4.read();}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){val=Serial5.read();}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){val=Serial6.read();}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){val=SerialS.read();}
#endif	
return 	val;	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.6. uartWrite(n,val)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: uartWrite(uint8_t n, uint8_t val){
#ifdef RT_HW_PERMIT_UART0
if(n==0){Serial.write(val);}
#endif	
#ifdef RT_HW_PERMIT_UART1
if(n==1){Serial1.write(val);}
#endif		
#ifdef RT_HW_PERMIT_UART2
if(n==2){Serial2.write(val);}
#endif	
#ifdef RT_HW_PERMIT_UART3
if(n==3){Serial3.write(val);}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){Serial4.write(val);}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){Serial5.write(val);}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){Serial6.write(val);}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){SerialS.write(val);}
#endif		
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.7. uartPrint(n,str)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: uartPrint(uint8_t n, String str){
#ifdef RT_HW_PERMIT_UART0
if(n==0){Serial.print(str);}
#endif	
#ifdef RT_HW_PERMIT_UART1
if(n==1){Serial1.print(str);}
#endif		
#ifdef RT_HW_PERMIT_UART2
if(n==2){Serial2.print(str);}
#endif	
#ifdef RT_HW_PERMIT_UART3
if(n==3){Serial3.print(str);}
#endif
#ifdef RT_HW_PERMIT_UART4
if(n==4){Serial4.print(str);}
#endif	
#ifdef RT_HW_PERMIT_UART5
if(n==5){Serial5.print(str);}
#endif
#ifdef RT_HW_PERMIT_UART6
if(n==6){Serial6.print(str);}
#endif
#ifdef RT_HW_PERMIT_UARTS
if(n==7){SerialS.print(str);}
#endif		
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			14.7. Контроль наличия UART  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
bool RT_HW_BASE:: checkNumUART(uint8_t num){
//-----------------
if(num==0){
#ifdef RT_HW_PERMIT_UART0
return 1;
#endif
}
//-----------------
if(num==1){
#ifdef RT_HW_PERMIT_UART1
return 1;
#endif
}
//-----------------
if(num==2){
#ifdef RT_HW_PERMIT_UART2
return 1;
#endif
}
//-----------------
if(num==3){
#ifdef RT_HW_PERMIT_UART3
return 1;
#endif
}
//-----------------
if(num==4){
#ifdef RT_HW_PERMIT_UART4
return 1;
#endif
}
//-----------------
if(num==5){
#ifdef RT_HW_PERMIT_UART5
return 1;
#endif
}
//-----------------
if(num==6){
#ifdef RT_HW_PERMIT_UART6
return 1;
#endif
}
//-----------------
if(num==7){
#ifdef RT_HW_PERMIT_UARTS
return 1;
#endif
return 0;}
return 0;
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	