 #include "RT_HW_BASE.h"
//--Использовано https://soltau.ru/index.php/arduino/item/371-interfejs-i2c-i-arduino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 				1. Определение дополнительных шин i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----Дополнительные шины для STM32F1-------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F1)  && defined(RT_HW_PERMIT_I2C1)
  TwoWire Wire1(PB11,PB10);
#endif
//-----Дополнительные шины для STM32F401Cx,STM32F411Cx,--------------------------------------------
#if (defined(RT_HW_BOARD_STM32F401Cx) || defined(RT_HW_BOARD_STM32F411Cx)) && defined(RT_HW_PERMIT_I2C1)
  TwoWire Wire1(PB3, PB10);
#endif 
#if (defined(RT_HW_BOARD_STM32F401xx) || defined(RT_HW_BOARD_STM32F411xx)) && defined(RT_HW_PERMIT_I2C2)  
  TwoWire Wire2(PB4, PA8);
#endif  
//-----Дополнительные шины для STM32F407Vx-------------------------------------------------------------
#if defined(RT_HW_BOARD_STM32F407Vx)  && defined(RT_HW_PERMIT_I2C1)
  TwoWire Wire1(PB11,PB10);
#endif
#if defined(RT_HW_BOARD_STM32F407Vx)  && defined(RT_HW_PERMIT_I2C2)
  TwoWire Wire2(PH8,PH7	);
#endif
//-----Дополнительные шины  для BLACK_F407Vx-------------------------------------------------------------
#if defined(RT_HW_BOARD_BLACK_F407Vx) && defined(RT_HW_PERMIT_I2C1)
  TwoWire Wire1(PB11,PB10);
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 				2. Конвертация кода скорости в значение скорости  i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_BASE:: convertModeFreqWire(uint8_t mode){
if(mode==RT_HW_I2C_MODE_LOW)	{return RT_HW_I2C_SPEED_LOW;}
if(mode==RT_HW_I2C_MODE_ST)		{return RT_HW_I2C_SPEED_ST;} 
if(mode==RT_HW_I2C_MODE_FM)		{return RT_HW_I2C_SPEED_FM;}
if(mode==RT_HW_I2C_MODE_FM1) 	{return RT_HW_I2C_SPEED_FM1;}
if(mode==RT_HW_I2C_MODE_FM2) 	{return RT_HW_I2C_SPEED_FM2;}
if(mode==RT_HW_I2C_MODE_FMP) 	{return RT_HW_I2C_SPEED_FMP;}
if(mode==RT_HW_I2C_MODE_HS) 	{return RT_HW_I2C_SPEED_HS;}
if(mode==RT_HW_I2C_MODE_UFM) 	{return RT_HW_I2C_SPEED_UFM;};
return RT_HW_I2C_SPEED_ST;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1. Инициализация библиотеки и подключение к шине I2C; 
// Если адрес<0, то присоединённое устройство считается ведущим, 
//  иначе устройство настраивается как slave с адресом=adr;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireBegin(int8_t sda, int8_t scl, uint8_t slaveAdr, uint8_t bus){

//======Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
#if defined(RT_HW_PERMIT_I2C0)								//---шина i2c;
if(bus==0){				 if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT))       {return;};	//--Выход, если шина инициализирована;
					if(slaveAdr>=8){device.i2c0.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c0.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c0.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						 Wire.begin(device.i2c0.adr);} 											//				c адресом slaveAdr;
					else  {bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); Wire.begin();} 	//--Инициализация как master;
 Wire.setClock(convertModeFreqWire (device.i2c0.speed));										//--Установка частоты шины i2c;  
                           bitSet  (device.i2c0.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
return;   }																						//--Выход;				
#endif
#if defined(RT_HW_PERMIT_I2C1) && defined(RT_HW_ARCH_SAM3)	//---шина i2c1;
if(bus==1){				 if(bitRead(device.i2c1.state,RT_HW_I2C_STATE_INIT))       {return;};	//--Выход, если шина инициализирована;
					if(slaveAdr>=8){device.i2c1.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c1.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c1.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						Wire1.begin(device.i2c1.adr);} 											//				c адресом slaveAdr;
					else  {bitClear(device.i2c1.state ,RT_HW_I2C_STATE_SLAVE); Wire1.begin();} 	//--Инициализация как master;
 Wire1.setClock(convertModeFreqWire(device.i2c1.speed));										//--Установка частоты шины i2c;  
                           bitSet  (device.i2c1.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
return;   }																						//--Выход;						   
#endif		
#endif		//--END #if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE)	
//======Архитектура ESP8266----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_ESP8266) && defined(RT_HW_PERMIT_I2C0)		//---шина i2c;		
if(bus==0){ 			 if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT)) {return;};			//--Выход, если шина инициализирована;
if((sda>=0)&&(scl>=0)&& (sda!=scl)){device.i2c0.sda=sda; device.i2c0.scl=scl;}					//--Изменение пинов SDA,SCL;
					if(slaveAdr>=8){device.i2c0.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c0.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c0.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация 
						 Wire.begin(device.i2c0.sda,											//			как slave
									device.i2c0.scl,											//				c адресом 
									device.i2c0.adr);} 											//					slaveAdr;
					else  {bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); 					//--Инициализация 
						 Wire.begin(device.i2c0.sda,											//				как
									device.i2c0.scl);} 											//					master;						  
 Wire.setClock(convertModeFreqWire (device.i2c0.speed));										//--Установка частоты шины i2c;  
                           bitSet  (device.i2c0.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;					
	Wire.setClockStretchLimit(260);																//		ограничение лимита по времени;
return;   };																						//--Выход;			

#endif		//--END #if defined(RT_HW_ARCH_ESP)
//======Архитектура ESP32 (только master)---------------------------------------------------------
#if defined(RT_HW_ARCH_ESP32) && defined(RT_HW_PERMIT_I2C0)		//---шина i2c;		
if(bus==0){if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT)) {return;};						//--Выход, если шина инициализирована;
//Serial.println("TEST ESP32 scan");
if((sda>=0)&&(scl>=0)&& (sda!=scl)){device.i2c0.sda=sda; device.i2c0.scl=scl;}					//--Изменение пинов 
bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); 											//--Очистка пина Slave
Wire.begin();
Wire.begin(device.i2c0.sda, device.i2c0.scl,convertModeFreqWire (device.i2c0.speed));           //--Инициализация как master;						  
bitSet  (device.i2c0.state,RT_HW_I2C_STATE_INIT);												//--Установка флага INIT;					
return;   };																					//--Выход;			
#endif		//--END #if defined(RT_HW_ARCH_ESP)
//======Архитектура STM32---------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F1) || defined(RT_HW_ARCH_STM32F4) 
#if defined(RT_HW_PERMIT_I2C0)		//---шина i2c;
if(bus==0){uint8_t ok=0; if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT)) {return;};			//--Выход, если шина инициализирована;					
if(!ok){if((sda==PB7)&&(scl==PB6)) {device.i2c0.sda=PB7; device.i2c0.scl=PB6; ok=1;}}			//--Установка основных пинов шины i2c(PB7,PB6);
if(!ok){if((sda==PB9)&&(scl==PB8)) {device.i2c0.sda=PB9; device.i2c0.scl=PB8; ok=1;}}	        //--Установка альтерн. пинов шины i2c(PB9,PB8); 
if(!ok){                            device.i2c0.sda=SDA; device.i2c0.scl=SCL; ok=1;}			//--Если пины не вернs, установка по умолчанию; 
						Wire.setSDA(device.i2c0.sda);											//--Апппаратная настройка пина SDA;
						Wire.setSCL(device.i2c0.scl);											//--Апппаратная настройка пина SCL;
					if(slaveAdr>=8){device.i2c0.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c0.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c0.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						 Wire.begin(device.i2c0.adr);} 											//				c адресом slaveAdr;
					else  {bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); Wire.begin();} 	//--Инициализация как master;
  Wire.setClock(convertModeFreqWire(device.i2c0.speed));										//--Установка частоты шины i2c;  
                             bitSet(device.i2c0.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;	
return;   };																						//--Выход;		
#endif
#if defined(RT_HW_PERMIT_I2C1)		//--шина i2c1;
if(bus==1){      		if(bitRead (device.i2c1.state,RT_HW_I2C_STATE_INIT)) {return;};			//--Выход, если шина инициализирована;					
									device.i2c1.sda=PB11; device.i2c1.scl=PB10;					//--Установка пинов шины i2c(PB11,PB10);
					   Wire1.setSDA(device.i2c1.sda);											//--Апппаратная настройка пина SDA;
					   Wire1.setSCL(device.i2c1.scl);											//--Апппаратная настройка пина SCL;
					if(slaveAdr>=8){device.i2c1.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c1.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c1.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
					    Wire1.begin(device.i2c1.adr);} 											//				c адресом slaveAdr;
					else  {bitClear(device.i2c1.state ,RT_HW_I2C_STATE_SLAVE); Wire1.begin();} 	//--Инициализация как master;
 Wire1.setClock(convertModeFreqWire(device.i2c1.speed));										//--Установка частоты шины i2c;  
                             bitSet(device.i2c1.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
return;   }																						//--Выход;									 
#endif
#if defined(RT_HW_PERMIT_I2C2)		//--шина i2c2;
if(bus==2){        		 if(bitRead(device.i2c2.state,RT_HW_I2C_STATE_INIT)) {return;};			//--Выход, если шина инициализирована;					
									device.i2c2.sda=PB11; device.i2c2.scl=PB10;					//--Установка пинов шины i2c(PB11,PB10);
					   Wire2.setSDA(device.i2c2.sda);											//--Апппаратная настройка пина SDA;
					   Wire2.setSCL(device.i2c2.scl);											//--Апппаратная настройка пина SCL;
					if(slaveAdr>=8){device.i2c2.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								 if(device.i2c2.adr>=8)											//--Выбор режима настройки шины (slave/master);
						    {bitSet(device.i2c2.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						Wire2.begin(device.i2c2.adr);} 											//				c адресом slaveAdr;
					else  {bitClear(device.i2c2.state ,RT_HW_I2C_STATE_SLAVE); Wire2.begin();} 	//--Инициализация как master;
 Wire2.setClock(convertModeFreqWire(device.i2c2.speed));										//--Установка частоты шины i2c;  
                             bitSet(device.i2c2.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
return;   }																						//--Выход;									 
#endif
#endif		
};	//--END wireBegin(int8_t sda,int8_t scl, int8_t bus)
 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2. Установка частоты i2c 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireSetClock(uint8_t speed, uint8_t bus){
//-----Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){device.i2c0.speed=speed; Wire.setClock(convertModeFreqWire(device.i2c0.speed)); return;};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){device.i2c1.speed=speed; Wire1.setClock(convertModeFreqWire(device.i2c1.speed)); return;};
#endif
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){device.i2c2.speed=speed; Wire2.setClock(convertModeFreqWire(device.i2c2.speed)); return;};
#endif			
#endif		//--END #if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
//--------------------------------------------------------------------------------------------------	
};	//--END wireSetFreq(int8_t sda,int8_t scl, int8_t bus)

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3. Начало передачи данных от master к slave 
//			(далее могут следовать команды write() одного из форматов)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireBeginTransmission(int8_t adr, uint8_t bus){
//-----Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){if((bitRead(device.i2c0.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0))  {Wire.beginTransmission(adr);}  return;};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){if((bitRead(device.i2c1.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0)); {Wire1.beginTransmission(adr);} return;};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){if((bitRead(device.i2c2.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0)); {Wire2.beginTransmission(adr);} return;};
#endif			
#endif		//--END #if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
//--------------------------------------------------------------------------------------------------	
};	//--END  wireBeginTransmission(int8_t adr, int8_t bus)

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4. Инициирование команды отправки по указанному адресу
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: wireEndTransmission(uint8_t bus){
//-----Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){if((bitRead(device.i2c0.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire.endTransmission();} else {return 4;}};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){if((bitRead(device.i2c1.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire1.endTransmission();} else {return 4;}};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){if((bitRead(device.i2c2.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire2.endTransmission();} else {return 4;}};
#endif	
#endif
//--------------------------------------------------------------------------------------------------	
return 4;}	//--END  wireEndTransmission(int8_t bus)


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						7. Поиск устройства на шине i2c 
//  Вход: id.adr-адрес устройства; bus-номер шины I2c(по умолчанию=0); id.custom->при инициализации установить =0; 
//		  id.maxErr - максимальное количество ошибок (1-255) - по умолчанию=20:
//		  id.maxOk  - кол-во успешных повторов, после которого устройство считается обнаруженным (1-31) - по умолчанию=3;	
//  Если устройство с заданныим адресом не найдено, то период поиска изменяется от 100мс до (100 х cntMax).
//	Если устройство найдено, то делаются дополнительные запросы через 50мс (всего должно быть три успешных попытки подряд);
//  Выход: успешный выход 		 ->cnt=0, функция возвращает 1;
//		   устройство не найдено ->cnt>1, функция возвращает 0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//struct RT_HW_STRUCT_FIND_I2C{uint8_t custom=0;  uint8_t maxErr=20; uint8_t cntErr=0; uint8_t maxOk:4, cntOk:4; uint32_t timeDelay;}; 
bool RT_HW_BASE::findDeviceWire(RT_HW_STRUCT_FIND_I2C &id, uint8_t adr, uint8_t bus){
if(id.custom==0){return 0;}
if(id.custom==1){if(adr<0)	  {id.custom=0; return 0;} if(id.maxErr==0){id.maxErr=20;} if(id.maxOk==0) {id.maxOk=3;} 				  
				 id.cntErr=id.cntOk=0; id.timeDelay=RT_HW_MILLIS; id.custom=2;}			//--Сброс и установка параметров;
if(id.custom==2){if(RT_HW_MILLIS < id.timeDelay) {return 0;} 							//--Ожидание по времени;
	wireBeginTransmission(adr,bus);														//--Отправка запроса на шину i2c;
	if(wireEndTransmission(bus)==0){id.cntErr=0; id.timeDelay=RT_HW_MILLIS+50;	//--Завершение после 
	if(++id.cntOk>3){id.custom=3; return 1;} else {return 0;}} 					//		многократного успешного поиска;
	id.cntOk=0; if(id.cntErr<id.maxErr) {id.cntErr++;}  						//--Обработка 
	id.timeDelay=RT_HW_MILLIS+(100*id.cntErr); return 0;} 						//	 ошибочной транзакции;
if(id.custom==3) {return 1;}
return 0;};		

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6. Сканирование шины i2c (обнаружение подключенных устройств)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: scanDeviceWire(uint8_t bus){ if(printCheck()){
#if defined(RT_HW_PERMIT_I2C0)
if((bus==0) && (device.i2c0.adr==0)){uint8_t error; uint8_t qnt=0; String str=String(F("i2c0-> ")); printStr(str);	//--Вывод заголовка;  
wireBegin(device.i2c0.sda, device.i2c0.scl,0,bus); for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){printChar(',');} qnt++; printVal('H',2,'/',i); printInt8(i);}}
str=String(F("; qnt="));printStr(str); printInt8(qnt,'I',';'); printCR();}
#endif
#if defined(RT_HW_PERMIT_I2C1)
if((bus==1) && (device.i2c1.adr==0)){uint8_t error; uint8_t qnt=0; String str=String(F("i2c1-> ")); printStr(str);	//--Вывод заголовка;  
wireBegin(device.i2c1.sda, device.i2c1.scl,0,bus); for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){printChar(',');} qnt++; printVal('H',2,'/',i); printInt8(i);}}
str=String(F("; qnt="));printStr(str); printInt8(qnt,'I',';'); printCR();}
#endif
#if defined(RT_HW_PERMIT_I2C2)
if((bus==2) && (device.i2c2.adr==0)){uint8_t error; uint8_t qnt=0; String str=String(F("i2c2-> ")); printStr(str);	//--Вывод заголовка;  
wireBegin(device.i2c2.sda, device.i2c2.scl,0,bus); for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){printChar(',');} qnt++; printVal('H',2,'/',i); printInt8(i);}}
str=String(F("; qnt="));printStr(str); printInt8(qnt,'I',';'); printCR();}
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++










//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1. Инициализация библиотеки и подключение к шине I2C; 
// Если не указан адрес, то присоединённое устройство считается ведущим??? (доработать для slave); 
// Если sda>=0, scl<
/* Example pinmap for Bluepill I2Cs (by Testato)

 I2C-1 standard pins: PB7(sda) PB6(scl)
 Use it by "Wire" without pin declaration
  Wire.begin();

 I2C-1 alternative pins: PB9(sda) PB8(scl)
 Remap the first I2C before call begin()
  Wire.setSDA(PB9);
  Wire.setSCL(PB8);
  Wire.begin();

 I2C-2: PB11(sda) PB10(scl)
 Remap the second I2C before call begin()
  Wire.setSDA(PB11);
  Wire.setSCL(PB10);
  Wire.begin();

 If you want to use the two I2Cs simultaneously, create a new instance for the second I2C
  TwoWire Wire2(PB11,PB10);
  Wire2.begin();
 
*/